// 2dUq

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0302a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR2=200,X0=-68,Y0=140,k=180;
	double T1=20.0,T2=40.0,L=1.0/Math.sqrt(2.0);

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR2+80-1,FR2+20+1,FR2-80+1,-FR2-20-1,XColor.Color16[0]);
		XG.rectangle(-FR2+100,FR2,FR2-100,-FR2,XColor.Color16[0]);

		XG.set0(FC.x+X0,FC.y-Y0,0);
		int x0=XMath.fint(k*Math.sin(T1*Math.PI/180));
		int y0=XMath.fint(k*Math.cos(T1*Math.PI/180));
		int x1=XMath.fint(k*L*Math.sin(T2*Math.PI/180));
		int y1=XMath.fint(k*L*Math.cos(T2*Math.PI/180));
		XG.line(0,0,0,XMath.fint(k*(1+L)),XColor.Color16[0]);
		XG.line(x0,y0,x0,y0+XMath.fint(k*L),XColor.Color16[0]);
		XG.line(0,0,x0,y0,XColor.Color16[0],2);
		XG.line(x0,y0,x0+x1,y0+y1,XColor.Color16[0],2);
		XG.disk(0,0,4,XColor.Color16[0]);
		XG.disk(x0,y0,4,XColor.Color16[0]);
		XG.disk(x0+x1,y0+y1,4,XColor.Color16[0]);

		XG.string2(3,96,"",XColor.Color16[0],"Arial",Font.ITALIC,32);
		XG.string2(3+18,96+6,"1",XColor.Color16[0],"Arial",Font.PLAIN,20);
		XG.string2(x0+6,y0+60,"",XColor.Color16[0],"Arial",Font.ITALIC,32);
		XG.string2(x0+6+18,y0+60+6,"2",XColor.Color16[0],"Arial",Font.PLAIN,20);

		XG.string(10,140,"L="+XMath.fdouble(L,3),XColor.Color16[0],16);
		XG.string(10,160,"k="+k,XColor.Color16[0],16);
		XG.string(10,180,"T1="+T1,XColor.Color16[0],16);
		XG.string(10,200,"T2="+T2,XColor.Color16[0],16);
	}

	public F0302a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"2dUq");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0302a app=new F0302a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}