// ΂ːUq

package f03;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0303a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XTurtle XG;
	int FR2=300,X0=-70,Y0=20,N=6,L=(int)(150*1.8);
	double T=60.0;

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR2+180-1,FR2+20+1,FR2-180+1,-FR2-20-1,XColor.Color16[0]);
		XG.rectangle(-FR2+200,FR2-240,FR2-200,-FR2+20,XColor.Color16[0]);

		XG.set0(FC.x+X0,FC.y-Y0,0);
		XG.line(0,0,0,L,XColor.Color16[0]);
		XG.disk(0,0,4,XColor.Color16[0]);
		XG.setLP(0.0,0.0);
		XG.setAngle(T);
		XG.moveX((double)L/3,XColor.Color16[0],2);
		for(int i=0;i<N;i++)
		{   XG.turn(-60.0);
			XG.moveX((double)L/(6*N),XColor.Color16[0],2);
			XG.turn(120.0);
			XG.moveX((double)L/(3*N),XColor.Color16[0],2);
			XG.turn(-120.0);
			XG.moveX((double)L/(6*N),XColor.Color16[0],2);
			XG.turn(60.0);
		}

		XG.moveX((double)L/3,XColor.Color16[0],2);
		XG.disk(XMath.fint(XG.getLP()),4,XColor.Color16[0]);

		XG.string2(5,70,"",XColor.Color16[0],"Arial",Font.ITALIC,32);
		XG.string2(L/2,(int)(L*Math.sqrt(3.0)/2)-8,"x",XColor.Color16[0],"Arial",Font.ITALIC,32);

		XG.string(10,140,"L="+L,XColor.Color16[0],16);
		XG.string(10,160,"T="+T,XColor.Color16[0],16);
		XG.string(10,180,"N="+N,XColor.Color16[0],16);
	}

	public F0303a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"΂ːUq");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XTurtle(getGraphics());
	}

	public static void main(String[]argv)
	{	F0303a app=new F0303a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}