// lbg[Nfɂp^[̃tN^

package f06;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;

import javax.swing.*;
import xxx.*;

public class F0605 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=160,N=40,TL=(N+1)*(N+1)/2;
	double h=1.0/(N+1),dk=0.001,s_min=10000.0,D=0.0;
	double x_min=0.0,x_max=Math.log(N+1);
	double y_min=0.0,y_max=Math.log(N*N*5/8);
	int FR2=XMath.fint(y_max/x_max*FR);
	double Ax=(x_max-x_min)/(2*FR);
	double Bx=(x_max+x_min)/2;
	double Ay=(y_max-y_min)/(2*FR2);
	double By=(y_max+y_min)/2;
	double[]u=new double[(N+1)*(N+1)];
	int[][]Flag=new int[(N+1)*(N+1)][2];
	double[]f=new double[(N+1)*(N+1)];
	int[][]A=new int[(N+1)*(N+1)][(N+1)*(N+1)];
	int[]count=new int[N/2+1];
	int[]Nv=new int[(N+1)*(N+1)];
	int No=0;

	private void init()
	{	for(int i=0;i<(N+1)*(N+1);i++)
			f[i]=h*h;

		for(int j=0;j<(N+1)*(N+1);j++)
			for(int i=0;i<(N+1)*(N+1);i++)
				A[i][j]=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			A[i][i]=4;
		for(int i=0;i<N*(N+2);i++)
			A[i][i+1]=A[i+1][i]=-1;
		for(int i=0;i<N;i++)
			A[(N+1)*(i+1)-1][(N+1)*(i+1)]=A[(N+1)*(i+1)][(N+1)*(i+1)-1]=0;
		for(int i=0;i<N*(N+1);i++)
			A[i][i+(N+1)]=A[i+(N+1)][i]=-1;

		for(int i=0;i<(N+1)*(N+1);i++)
		{	Flag[i][0]=2;
			Flag[i][1]=0;
		}
		mod_Flag(N*(N+2)/2);
		for(int i=0;i<=N/2;i++)
			XG.cross(getSx(Math.log(2*i+1)),-FR2,2,XColor.Color16[0],3);
		for(int i=0;i<=N/2;i++)
			count[i]++;
		draw(0);
	}

	private void choleskyEx(int t)
	{	double[]v=new double[N*(N+2)-t];
		double[]g=new double[N*(N+2)-t];
		double[][]B=new double[N*(N+2)-t][N*(N+2)-t];
		int no=0,no_=0;
		int[]ord=new int[TL+1];

		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(Flag[i][0]==0)
			{	ord[no]=i;no++;
			}
		}
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
				no++;
			else
			{	g[i-no]=f[i];
				no_=0;
				for(int j=0;j<i;j++)
				{	if(j==ord[no_])
						no_++;
					else
						B[i-no][j-no_]=B[j-no_][i-no]=A[i][j];
				}
				B[i-no][i-no]=A[i][i];
			}
		}
		v=XAlgebra.cholesky(B,g);
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
			{	u[i]=0.0;no++;
			}
			else
				u[i]=v[i-no];
		}
	}

	private void get_u(int t)
	{	f[Nv[No]]=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	A[i][Nv[No]]=0;
			A[Nv[No]][i]=0;
		}
		A[Nv[No]][Nv[No]]=1;
		choleskyEx(t);
		No++;
	}

	private void mod_Flag(int n)
	{	Flag[n][0]=0;
		Nv[No]=n;

		int x=n%(N+1),y=n/(N+1);
		if(x==0)
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else if(x==N)
			if(y==0)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
	}

	private void mod_Flag2(int n,int n_)
	{	if(Flag[n][0]==2)
		{	Flag[n][0]=1;
			Flag[n][1]=n_;
		}
	}

	private void sort(int t)
	{	int no=0;
		double max=0.0;

		max=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==1)
				if(u[i]>max)
				{	max=u[i];
					no=i;
				}

		int x=no%(N+1),y=no/(N+1);
		int n=Math.max(Math.abs(x-N/2),Math.abs(y-N/2));
		for(int i=n;i<=N/2;i++)
		{	count[i]++;
			draw(i);
		}
		mod_Flag(no);
	}

	private void draw(int n)
	{	int sx=getSx(Math.log(2*n+1));
		int sy=getSy(Math.log(count[n]));
		if(Math.abs(sy)<=FR2)
			XG.cross(sx,sy,2,XColor.Color16[0],3);
	}

	private void regression()
	{	for(double k=1.0;k<2.0;k+=dk)
		{	double s=0.0;
			for(int i=0;i<=N/2;i++)
			{	double t=k*Math.log(2*i+1)-Math.log(count[i]);
				s=s+t*t;
			}
			if(s<s_min)
			{	s_min=s;
				D=k;
			}
		}
		XG.line(-FR,-FR2,FR,XMath.fint(D*FR),XColor.Color16[0],2);
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC.x,FC.y-20,1);
		XG.rectangle(-FR-80-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);
		XG.line(getSx(Math.log(5)),-FR2,getSx(Math.log(5)),FR2,XColor.Color16[8]);
		XG.line(getSx(Math.log(10)),-FR2,getSx(Math.log(10)),FR2,XColor.Color16[8]);
		XG.line(getSx(Math.log(25)),-FR2,getSx(Math.log(25)),FR2,XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(5)),FR,getSy(Math.log(5)),XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(10)),FR,getSy(Math.log(10)),XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(50)),FR,getSy(Math.log(50)),XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(100)),FR,getSy(Math.log(100)),XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(500)),FR,getSy(Math.log(500)),XColor.Color16[8]);
		XG.line(-FR,getSy(Math.log(1000)),FR,getSy(Math.log(1000)),XColor.Color16[8]);

		init();
		for(int t=0;t<TL;t++)
		{	get_u(t);
			sort(t);
		}

		regression();

		int Tot=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==0)
				Tot++;
		int TotC=0;
		for(int i=0;i<=N/2;i++)
			TotC=TotC+count[i];

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);

		XG.string2(-FR/2-15,-FR2-48,"r",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-9,-FR2-30,""+XMath.fint(Math.exp(x_min)),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(Math.log(5))-9,-FR2-30,"5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(Math.log(10))-18,-FR2-30,"10",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(getSx(Math.log(25))-18,-FR2-30,"25",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-40,FC.y+30,"N",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.stringR(FC.x-FR-32,FC.y+30-28,"r",XColor.Color16[0],
			"Arial",Font.ITALIC,29,90.0);
		XG.string2(-FR-23,-FR2-8,""+XMath.fint(Math.exp(y_min)),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-23,getSy(Math.log(5))-12,"5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-41,getSy(Math.log(10))-12,"10",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-41,getSy(Math.log(50))-12,"50",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-59,getSy(Math.log(100))-12,"100",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-59,getSy(Math.log(500))-12,"500",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-77,getSy(Math.log(1000))-12,"1000",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,140,"N="+N,XColor.Color16[0],16);
		XG.string(10,160,"(N+1)*(N+1)="+(N+1)*(N+1),XColor.Color16[0],16);
		XG.string(10,180,"h="+XMath.fdouble(h,5),XColor.Color16[0],16);
		XG.string(10,200,"TL="+TL,XColor.Color16[0],16);
		XG.string(10,300,"No="+No,XColor.Color16[0],16);
		XG.string(10,320,"Nv[0]="+Nv[0],XColor.Color16[0],16);
		XG.string(10,340,"Nv["+(No-1)+"]="+Nv[No-1],XColor.Color16[0],16);
		XG.string(10,400,"count[0]="+count[0],XColor.Color16[0],16);
		XG.string(10,420,"count[N/2]="+count[N/2],XColor.Color16[0],16);
		XG.string(10,500,"x="+XMath.fdouble(x_min,3)+"<<"+XMath.fdouble(x_max,3),XColor.Color16[0],16);
		XG.string(10,520,"y="+XMath.fdouble(y_min,3)+"<<"+XMath.fdouble(y_max,3),XColor.Color16[0],16);
		XG.string(10,600,"D="+XMath.fdouble(D,3),XColor.Color16[0],16);
		XG.string(10,620,"Tot="+Tot,XColor.Color16[0],16);
		XG.string(10,640,"TotC="+TotC,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	public F0605()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"lbg[Nfɂp^[̃tN^");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0605 app=new F0605();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}