// lbg[NfɂՊEZ̏o͒l̎ԕω

package f06;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;

import javax.swing.*;
import xxx.*;

public class F0607a extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=300,FR2=2*FR/3,N=40,TL=100;
	double ub=1.0;
	int NX=10,NY=4;
	double x_min=0.0,x_max=(double)TL,u_=0.0;
	double y_min=0.0,y_max=0.4;
	double Ax=(x_max-x_min)/(2*FR);
	double Bx=(x_max+x_min)/2;
	double Ay=(y_max-y_min)/(2*FR2);
	double By=(y_max+y_min)/2;
	double[]u=new double[(N+1)*(N+1)];
	int[][]Flag=new int[(N+1)*(N+1)][2];
	double[]f=new double[(N+1)*(N+1)];
	int[][]A=new int[(N+1)*(N+1)][(N+1)*(N+1)];
	int[]Nv=new int[(N+1)*(N+1)];
	int No=0;

	private void init()
	{	for(int i=0;i<(N+1)*(N+1);i++)
			f[i]=0.0;
		for(int i=0;i<=N;i++)
		{	f[i]=f[i]+ub;
			f[N*(N+1)+i]=f[N*(N+1)+i]+ub;
			f[(N+1)*i]=f[(N+1)*i]+ub;
			f[(N+1)*i+N]=f[(N+1)*i+N]+ub;
		}

		for(int j=0;j<(N+1)*(N+1);j++)
			for(int i=0;i<(N+1)*(N+1);i++)
				A[i][j]=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			A[i][i]=4;
		for(int i=0;i<N*(N+2);i++)
			A[i][i+1]=A[i+1][i]=-1;
		for(int i=0;i<N;i++)
			A[(N+1)*(i+1)-1][(N+1)*(i+1)]=A[(N+1)*(i+1)][(N+1)*(i+1)-1]=0;
		for(int i=0;i<N*(N+1);i++)
			A[i][i+(N+1)]=A[i+(N+1)][i]=-1;

		for(int i=0;i<(N+1)*(N+1);i++)
		{	Flag[i][0]=2;
			Flag[i][1]=0;
		}
		mod_Flag(N*(N+2)/2);
	}

	private void choleskyEx(int t)
	{	double[]v=new double[N*(N+2)-t];
		double[]g=new double[N*(N+2)-t];
		double[][]B=new double[N*(N+2)-t][N*(N+2)-t];
		int no=0,no_=0;
		int[]ord=new int[TL+2];

		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(Flag[i][0]==0)
			{	ord[no]=i;no++;
			}
		}
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
				no++;
			else
			{	g[i-no]=f[i];
				no_=0;
				for(int j=0;j<i;j++)
				{	if(j==ord[no_])
						no_++;
					else
						B[i-no][j-no_]=B[j-no_][i-no]=A[i][j];
				}
				B[i-no][i-no]=A[i][i];
			}
		}
		v=XAlgebra.cholesky(B,g);
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
			{	u[i]=0.0;no++;
			}
			else
				u[i]=v[i-no];
		}
	}

	private void get_u(int t)
	{	f[Nv[No]]=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	A[i][Nv[No]]=0;
			A[Nv[No]][i]=0;
		}
		A[Nv[No]][Nv[No]]=1;
		choleskyEx(t);
		No++;
	}

	private void mod_Flag(int n)
	{	Flag[n][0]=0;
		Nv[No]=n;

		int x=n%(N+1),y=n/(N+1);
		if(x==0)
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else if(x==N)
			if(y==0)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
	}

	private void mod_Flag2(int n,int n_)
	{	if(Flag[n][0]==2)
		{	Flag[n][0]=1;
			Flag[n][1]=n_;
		}
	}

	private void sort(int t)
	{	int no=0;
		double min=ub;

		min=ub;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==1)
				if(u[i]<min)
				{	min=u[i];
					no=i;
				}

		mod_Flag(no);
		draw(u[no],t);
		u_=u[no];
	}

	private void draw(double u,int t)
	{	int sy_=0,sy=0;
		int sx_=getSx(t-1);
		int sx=getSx(t);
		sy_=getSy(u_);
		sy=getSy(u);
		if(Math.abs(sy)<=FR2&&Math.abs(sy_)<=FR2)
		{	XG.cross(sx,sy,3,XColor.Color16[0],3);
			if(t!=0)
				XG.line(sx_,sy_,sx,sy,XColor.Color16[0],2);
		}
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX;
		double DY=2.0*FR2/NY;
		for(int i=1;i<NX;i++)
			XG.line(-FR+i*DX,-FR2,-FR+i*DX,FR2,XColor.Color16[8]);
		for(int i=1;i<NY;i++)
			XG.line(-FR,-FR2+XMath.fint(i*DY),FR,-FR2+XMath.fint(i*DY),XColor.Color16[8]);

		init();
		for(int t=0;t<=TL;t++)
		{	get_u(t);
			sort(t);
		}

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);

		XG.string2(FR-54,FR2-44,"(a)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/2-6,-FR2-52,"t",XColor.Color16[0],
			"Arial",Font.ITALIC,32);
		XG.string2(-FR-9,-FR2-30,""+XMath.fint(x_min),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-18,-FR2-30,""+XMath.fint((x_min+x_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-36,-FR2-30,""+XMath.fint(x_max),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-22,FC.y-FR2/2+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,32,90.0);
		XG.string2(-FR-23,-FR2-8,""+XMath.fint(y_min),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+(y_min+y_max)/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR2-12,""+y_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int Tot=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==0)
				Tot++;

		XG.string(10,140,"N="+N,XColor.Color16[0],16);
		XG.string(10,160,"(N+1)*(N+1)="+(N+1)*(N+1),XColor.Color16[0],16);
		XG.string(10,220,"TL="+TL,XColor.Color16[0],16);
		XG.string(10,300,"No="+No,XColor.Color16[0],16);
		XG.string(10,320,"Nv[0]="+Nv[0],XColor.Color16[0],16);
		XG.string(10,340,"Nv["+(No-1)+"]="+Nv[No-1],XColor.Color16[0],16);
		XG.string(10,600,"x="+XMath.fdouble(x_min,3)+"<<"
			+XMath.fdouble(x_max,3),XColor.Color16[0],16);
		XG.string(10,620,"y="+XMath.fdouble(y_min,3)+"<<"
			+XMath.fdouble(y_max,3),XColor.Color16[0],16);
		XG.string(10,700,"Tot="+Tot,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	public F0607a()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"lbg[NfɂՊEZ̏o͒l̎ԕω");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0607a app=new F0607a();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}