// XColorFJ[NX

package xxx;

import java.awt.Color;

public final class XColor
{	// 16FJ[[h
	// ,,,F,,,F,,
	// DF,,,F,,,F,DF
	public static final Color[]Color16
		={new Color(  0,  0,  0),new Color(  0,  0,255),
		  new Color(  0,255,  0),new Color(  0,255,255),
		  new Color(255,  0,  0),new Color(255,  0,255),
		  new Color(255,255,  0),new Color(255,255,255),
		  new Color(192,192,192),new Color(128,128,255),
		  new Color(128,255,128),new Color(128,255,255),
		  new Color(255,128,128),new Color(255,128,255),
		  new Color(255,255,128),new Color(128,128,128)};
	// `J[
	private static Color[]frc=new Color[256];
	// AeXyNg̐ݒ
	public static void setShdSpectra(int c0,int c1)
	{	int[]rgb=new int[3];
		int[]col0=new int[3];
		int[]col1=new int[3];
		c0=c0%8;c1=c1%8;
		col0[0]=(c0>>2)&1;col0[1]=(c0>>1)&1;col0[2]=c0&1;
		col1[0]=(c1>>2)&1;col1[1]=(c1>>1)&1;col1[2]=c1&1;
		for(int i=0;i<256;i++)
		{	for(int j=0;j<3;j++)
				rgb[j]=col0[j]*(255-i)+col1[j]*i;
			frc[i]=new Color(rgb[0],rgb[1],rgb[2]);
		}
	}
	// zXyNg(1)̐ݒ
	public static void setCycSpectra(int c)
	{	setCycSpectra(c,c);
	}
	// zXyNg(2)̐ݒ
	public static void setCycSpectra(int c0,int c1)
	{	int d;
		int[]n={0,2,1,4,5,3};
		int[]rgb=new int[3];
		int[][]st={{2,4,0},{4,0,2},{3,5,1},{0,2,4},{1,3,5},{5,1,3}};
		c0=c0%8;c1=c1%8;
		if((c0==0)||(c0==7))
			c0=1;
		if((c1==0)||(c1==7))
			c1=1;
		if(c0==c1)
			d=6;
		else
			d=(n[c1-1]-n[c0-1]+6)%6;
		int[][]RGB=new int[3][d*256];
		for(int i=0;i<d*256;i++)
		{	for(int j=0;j<3;j++)
				RGB[j][i]=getElement((i/256+st[c0-1][j])%6,i%256);
		}
		for(int i=0;i<256;i++)
		{	for(int j=0;j<3;j++)
				rgb[j]=RGB[j][d*i];
			frc[i]=new Color(rgb[0],rgb[1],rgb[2]);
		}
	}
	// zXyNgpJ[vf̎擾
	private static int getElement(int i,int j)
	{	switch(i)
		{	case 0:return 255;
			case 1:return 255-j;
			case 2:return 0;
			case 3:return 0;
			case 4:return j;
			case 5:return 255;
		}
		return 0;
	}
	// 256F`J[̎擾(0)
	public static Color getColor(int n)
	{	if(n<0)
		return frc[0];
		else if(n>255)
			return frc[255];
		else
			return frc[n];
	}
	// 256F`J[̎擾(1)
	public static Color getColor(int n,int N)
	{	double k=(double)N/256;
		double x=(double)n/N;
		int c=(int)(256*(1-Math.pow(1-x,k)));
		if(c<256)
			return frc[c];
		else
			return frc[0];
	}
	// 256F`J[̎擾(2)
	public static Color getColor(int n,int N,double k)
	{	double x=(double)n/N;
		int c=(int)(256*Math.pow((1-Math.pow(1-x,k)),1.0/k));
		if(c<256)
			return frc[c];
		else
			return frc[0];
	}
	// 256F`J[̎擾(3)
	public static Color getColor2(int n,int N,double k)
	{	double x=(double)n/N;
		int c=(int)(256*Math.pow(x,1.0/k));
		if(c<256)
			return frc[c];
		else
			return frc[0];
	}
	// 256F`J[̎擾(1')
	public static Color getColor(int d,int No,int n,int N)
	{	int dn=256/d;
		double k=(double)N/dn;
		double x=(double)n/N;
		int c=(int)(dn*(1-Math.pow(1-x,k)));
		if(c<dn)
			return frc[No*dn+c];
		else
			return frc[No*dn];
	}
	// 256F`J[̎擾(2')
	public static Color getColor(int d,int No,int n,int N,double k)
	{	int dn=256/d;
		double x=(double)n/N;
		int c=(int)(dn*Math.pow((1-Math.pow(1-x,k)),1.0/k));
		if(c<dn)
			return frc[No*dn+c];
		else
			return frc[No*dn];
	}
	// 256F`J[̎擾(3')
	public static Color getColor2(int d,int No,int n,int N,double k)
	{	int dn=256/d;
		double x=(double)n/N;
		int c=(int)(dn*Math.pow(x,1.0/k));
		if(c<dn)
			return frc[No*dn+c];
		else
			return frc[No*dn];
	}
	// AIRXyNg
	private static Color[]aoko=new Color[256];
	// AIRXyNg̐ݒF
	public static void setAokoSpectra2()
	{	for(int i=0;i<128;i++)
		{	aoko[i]=new Color(0,2*i,255);
			aoko[128+i]=new Color(0,255,255-2*i);
		}
	}
	// AIRXyNg̐ݒF
	public static void setAokoSpectra3()
	{	for(int i=0;i<85;i++)
		{	aoko[i]=new Color(0,3*i,255);
			aoko[85+i]=new Color(0,255,255-3*i);
			aoko[170+i]=new Color(3*i,255,0);
		}
		aoko[255]=new Color(255,255,0);
	}
	// AIRXyNg̐ݒF
	public static void setAokoSpectra4()
	{	for(int i=0;i<64;i++)
		{	aoko[i]=new Color(0,4*i,255);
			aoko[64+i]=new Color(0,255,255-4*i);
			aoko[128+i]=new Color(4*i,255,0);
			aoko[192+i]=new Color(255,255-4*i,0);
		}
	}
	// AIRXyNg̎擾
	public static Color getAokoColor(int n)
	{	if(n<0)
			return aoko[0];
		else if(n>255)
			return aoko[255];
		else
			return aoko[n];
	}
}
