// XGraphics3DF3OtBbNXNX

package xxx;

import java.awt.*;
import javax.swing.JFrame;

public class XGraphics3D extends XGraphics
{	// x̉̉]p
	private double Rtx;
	// ỷ̉]p
	private double Rty;
	// _zW
	private double VPz;
	// RXgN^(1)
	public XGraphics3D(Graphics g)
	{	super(g);
		setPers(0.0,0.0,1000.0);
	}
	// RXgN^(2)
	public XGraphics3D(Graphics2D g)
	{	super(g);
		setPers(0.0,0.0,1000.0);
	}
	// RXgN^(3)
	public XGraphics3D(JFrame fr)
	{	super(fr);
		setPers(0.0,0.0,1000.0);
	}
	// ]p̐ݒ
	public void setProj(double rtx,double rty)
	{	Rtx=rtx;Rty=rty;
	}
	// e_̎擾...y,x̉̉](1)
	public XPointD3 getProj(double x,double y,double z)
	{	double sin_x=Math.sin(Rtx*Math.PI/180);
		double cos_x=Math.cos(Rtx*Math.PI/180);
		double sin_y=Math.sin(Rty*Math.PI/180);
		double cos_y=Math.cos(Rty*Math.PI/180);
		double xx=x*cos_y+z*sin_y;
		double yy=x*sin_x*sin_y+y*cos_x-z*sin_x*cos_y;
		double zz=-x*cos_x*sin_y+y*sin_x+z*cos_x*cos_y;
		return new XPointD3(xx,yy,zz);
	}
	// e_̎擾...y,x̉̉](2)
	public XPointD3 getProj(XPointD3 p)
	{	return getProj(p.x,p.y,p.z);
	}
	// ]pƎ_̐ݒ
	public void setPers(double rtx,double rty,double vpz)
	{	Rtx=rtx;Rty=rty;VPz=vpz;
	}
	// _̎擾(1)
	public XPointD3 getPers(double x,double y,double z)
	{	XPointD3 pr=getProj(x,y,z);
		double h=-pr.z/VPz+1;
		return new XPointD3(pr.x/h,pr.y/h,pr.z);
	}
	// _̎擾(2)
	public XPointD3 getPers(XPointD3 p)
	{	return getPers(p.x,p.y,p.z);
	}
	// x̉̉](1)
	public XPointD3 rotX(double x,double y,double z,double rtx)
	{	double sin_x=Math.sin(rtx*Math.PI/180);
		double cos_x=Math.cos(rtx*Math.PI/180);
		double xx=x;
		double yy=y*cos_x-z*sin_x;
		double zz=y*sin_x+z*cos_x;
		return new XPointD3(xx,yy,zz);
	}
	// x̉̉](2)
	public XPointD3 rotX(XPointD3 p,double rtx)
	{	return rotX(p.x,p.y,p.z,rtx);
	}
	// ỷ̉](1)
	public XPointD3 rotY(double x,double y,double z,double rty)
	{	double sin_y=Math.sin(rty*Math.PI/180);
		double cos_y=Math.cos(rty*Math.PI/180);
		double xx=x*cos_y+z*sin_y;
		double yy=y;
		double zz=-x*sin_y+z*cos_y;
		return new XPointD3(xx,yy,zz);
	}
	// ỷ̉](2)
	public XPointD3 rotY(XPointD3 p,double rty)
	{	return rotY(p.x,p.y,p.z,rty);
	}
	// z̉̉](1)
	public XPointD3 rotZ(double x,double y,double z,double rtz)
	{	double sin_z=Math.sin(rtz*Math.PI/180);
		double cos_z=Math.cos(rtz*Math.PI/180);
		double xx=x*cos_z-y*sin_z;
		double yy=x*sin_z+y*cos_z;
		double zz=z;
		return new XPointD3(xx,yy,zz);
	}
	// z̉̉](2)
	public XPointD3 rotZ(XPointD3 p,double rtz)
	{	return rotZ(p.x,p.y,p.z,rtz);
	}
}
