// WXeBbNȐ

package f01;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class F0101 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=300,FR2=2*FR/3,NX=5,NY=5;
	double u0=0.01;
	double t_min=0.0,t_max=12.5;
	double u_min=0.0,u_max=1.25;
	double Ax=(t_max-t_min)/(2*FR);
	double Bx=(t_max+t_min)/2;
	double Ay=(u_max-u_min)/(2*FR2);
	double By=(u_max+u_min)/2;

	private double func(double t)
	{	return u0/(u0+(1-u0)*Math.exp(-t));
	}

	private void myPaint()
	{	XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX,DY=2*FR2/NY;
		for(int i=1;i<NX;i++)
			XG.line(-FR+i*DX,-FR2,-FR+i*DX,FR2,XColor.Color16[8]);
		for(int i=1;i<NY;i++)
			XG.line(-FR,-FR2+i*DY,FR,-FR2+i*DY,XColor.Color16[8]);

		int sx_=0,sy_=0;
		for(int sx=-FR;sx<=FR;sx++)
		{	double t=setSx(sx);
			double u=func(t);
			int sy=getSy(u);
			if(sx!=-FR)
				XG.line(sx_,sy_,sx,sy,XColor.Color16[0],2);
			sx_=sx;sy_=sy;
		}

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);
		XG.rectangle(-FR-1,FR2+1,FR+1,-FR2-1,XColor.Color16[0]);
		XG.rectangle(-FR+1,FR2-1,FR-1,-FR2+1,XColor.Color16[0]);

		XG.string2(FR/5-8,-FR2-52,"t",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(-FR-8,-FR2-32,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR/5-8,-FR2-32,"5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(3*FR/5-20,-FR2-32,"10",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-32,FC.y-FR2/5+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR2-12,"0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-FR2/5-12,"0.5",XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,3*FR2/5-12,"1.0",XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.string(10,300,"u0="+u0,XColor.Color16[0],16);
		XG.string(10,440,"t="+t_min+"<<"+t_max,XColor.Color16[0],16);
		XG.string(10,460,"u="+u_min+"<<"+u_max,XColor.Color16[0],16);
	}

	public F0101()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"WXeBbNȐ");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0101 app=new F0101();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}