// AIRXyNg

package f04;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import xxx.*;

public class Aoko4_00p80 extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=40,FR2=100;
	double v_min=0.0,v_max=8.0;

	private void myPaint()
	{	XColor.setAokoSpectra4();
		XG.set0(FC,1);
		XG.rectangle(-FR-1,FR2+14+1,FR+1,-FR2-36-1,XColor.Color16[0]);

		for(int i=0;i<256;i++)
			XG.rectangleF(-30,XMath.fint((i-128)*(double)FR2/128),
				6,XMath.fint((i+1-128)*(double)FR2/128),XColor.getAokoColor(i));

		XG.rectangle(-30,-FR2,6,FR2,XColor.Color16[0]);
		XG.line(-30,0,6,0,XColor.Color16[0]);

		XG.stringR(FC.x+FR-10,FC.y-FR2/2+7,"v",XColor.Color16[0],
			"Arial",Font.ITALIC,20,90.0);
		XG.string2(12,-FR2-7,""+XMath.fint(v_min),XColor.Color16[0],"Arial",Font.PLAIN,18);
		XG.string2(12,-7,""+XMath.fdouble((v_min+v_max)/2,1),XColor.Color16[0],"Arial",Font.PLAIN,18);
		XG.string2(12,FR2-7,""+v_max,XColor.Color16[0],"Arial",Font.PLAIN,18);
	}

	public Aoko4_00p80()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"AIRXyNg");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{   Aoko4_00p80 app=new Aoko4_00p80();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}