// lbg[Nf̏

package f06;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;

import javax.swing.*;
import xxx.*;

public class F0602c extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=300,FR2=2*FR/3,NX=8,NY=4,N=40;
	double h=1.0/(N+1);
	double n_min=0.0,n_max=(double)N;
	double u_min=0.0,u_max=0.8;
	double Ax=(n_max-n_min)/(2*FR);
	double Bx=(n_max+n_min)/2;
	double Ay=(u_max-u_min)/(2*FR2);
	double By=(u_max+u_min)/2;
	double[]u=new double[(N+1)*(N+1)];
	double[]f=new double[(N+1)*(N+1)];
	int[][]A=new int[(N+1)*(N+1)][(N+1)*(N+1)];

	private void init()
	{	for(int i=0;i<(N+1)*(N+1);i++)
		f[i]=h*h;

		for(int j=0;j<(N+1)*(N+1);j++)
			for(int i=0;i<(N+1)*(N+1);i++)
				A[i][j]=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			A[i][i]=4;
		for(int i=1;i<N;i++)
		{	A[i][i]=3;
			A[N*(N+1)+i][N*(N+1)+i]=3;
			A[(N+1)*i][(N+1)*i]=3;
			A[(N+1)*i+N][(N+1)*i+N]=3;
		}
		A[0][0]=2;
		A[N][N]=2;
		A[N*(N+1)][N*(N+1)]=2;
		A[N*(N+2)][N*(N+2)]=2;
		for(int i=0;i<N*(N+2);i++)
			A[i][i+1]=A[i+1][i]=-1;
		for(int i=0;i<N;i++)
			A[(N+1)*(i+1)-1][(N+1)*(i+1)]=A[(N+1)*(i+1)][(N+1)*(i+1)-1]=0;
		for(int i=0;i<N*(N+1);i++)
			A[i][i+(N+1)]=A[i+(N+1)][i]=-1;

		f[N*(N+2)/2]=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	A[i][N*(N+2)/2]=0;
			A[N*(N+2)/2][i]=0;
		}
		A[N*(N+2)/2][N*(N+2)/2]=1;
	}

	private void get_u()
	{	u=XAlgebra.cholesky(A,f);
	}

	private void draw()
	{	int sx_=0,sy_=0;
		for(int j=0;j<=N;j++)
		{	for(int i=0;i<=N;i++)
			{	int sx=getSx(i);
				int sy=getSy(u[i+(N+1)*j]);
				if(Math.abs(sy)<=FR2&&Math.abs(sy_)<=FR2)
				{	XG.cross(sx,sy,3,XColor.Color16[0],3);
					if(i!=0)
						XG.line(sx_,sy_,sx,sy,XColor.Color16[0]);
				}
				sx_=sx;sy_=sy;
			}
		}
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-60-1,FR2+20+1,FR+20+1,-FR2-60-1,XColor.Color16[0]);

		int DX=2*FR/NX;
		double DY=2.0*FR2/NY;
		for(int i=1;i<NX;i++)
			XG.line(-FR+i*DX,-FR2,-FR+i*DX,FR2,XColor.Color16[8]);
		for(int i=1;i<NY;i++)
			XG.line(-FR,-FR2+XMath.fint(i*DY),FR,-FR2+XMath.fint(i*DY),XColor.Color16[8]);

		init();
		get_u();
		draw();

		XG.rectangle(-FR,FR2,FR,-FR2,XColor.Color16[0]);

		XG.string2(FR-61,-FR2+20,"(c)",XColor.Color16[0],
			"Arial",Font.PLAIN,40);

		XG.string2(FR/2-18,-FR2-52,"n",XColor.Color16[0],
			"Arial",Font.ITALIC,40);
		XG.string2(FR/2-18+21,-FR2-56,"x",XColor.Color16[0],
			"Arial",Font.ITALIC,29);
		XG.string2(-FR-9,-FR2-32,""+XMath.fint(n_min),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-18,-FR2-32,""+XMath.fint((n_min+n_max)/2),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(FR-18,-FR2-32,""+XMath.fint(n_max),XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		XG.stringR(FC.x-FR-18,FC.y-FR2/2+11,"u",XColor.Color16[0],
			"Arial",Font.ITALIC,40,90.0);
		XG.string2(-FR-23,-FR2-8,""+XMath.fint(u_min),XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,-12,""+(u_min+u_max)/2,XColor.Color16[0],
			"Arial",Font.PLAIN,32);
		XG.string2(-FR-50,FR2-12,""+u_max,XColor.Color16[0],
			"Arial",Font.PLAIN,32);

		int Tot=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(u[i]==0.0)
				Tot++;

		XG.string(10,140,"N="+N,XColor.Color16[0],16);
		XG.string(10,160,"(N+1)*(N+1)="+(N+1)*(N+1),XColor.Color16[0],16);
		XG.string(10,180,"h="+XMath.fdouble(h,5),XColor.Color16[0],16);
		XG.string(10,600,"n="+XMath.fint(n_min)+"<<"+XMath.fint(n_max),XColor.Color16[0],16);
		XG.string(10,620,"u="+XMath.fdouble(u_min,3)+"<<"+XMath.fdouble(u_max,3),XColor.Color16[0],16);
		XG.string(10,700,"Tot="+Tot,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	public F0602c()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"lbg[Nf̏");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0602c app=new F0602c();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}

	private double setSx(int x){return Ax*x+Bx;}
	private double setSy(int y){return Ay*y+By;}
	private int getSx(double x){return XMath.fint((x-Bx)/Ax);}
	private int getSy(double y){return XMath.fint((y-By)/Ay);}
}