// ͓`fɂlbg[Np^[

package f06;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import javax.swing.*;
import xxx.*;

public class F0608c extends XFrame implements ActionListener
{	String[]file={"Start","Clear","Exit"};
	JButton[]bt=new JButton[file.length];
	XGraphics XG;
	int FR=300,N=40,TL=(N+1)*(N+1)/2;
	double h=1.0/(N+1),d=(double)FR/(N+1);
	double w_max=4.0/3*d,w_min=d/3,dr=0.5;
	double[]u=new double[(N+1)*(N+1)];
	int[][]Flag=new int[(N+1)*(N+1)][2];
	Random Rd=new Random(0);
	double[]rd=new double[(N+1)*(N+1)];
	double[]f=new double[(N+1)*(N+1)];
	int[][]A=new int[(N+1)*(N+1)][(N+1)*(N+1)];
	int[]Nv=new int[(N+1)*(N+1)];
	int No=0;

	private void init()
	{	for(int i=0;i<(N+1)*(N+1);i++)
			rd[i]=1+dr*(2*Rd.nextDouble()-1);

		for(int i=0;i<(N+1)*(N+1);i++)
			f[i]=h*h;

		for(int j=0;j<(N+1)*(N+1);j++)
			for(int i=0;i<(N+1)*(N+1);i++)
				A[i][j]=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			A[i][i]=4;
		for(int i=0;i<N*(N+2);i++)
			A[i][i+1]=A[i+1][i]=-1;
		for(int i=0;i<N;i++)
			A[(N+1)*(i+1)-1][(N+1)*(i+1)]=A[(N+1)*(i+1)][(N+1)*(i+1)-1]=0;
		for(int i=0;i<N*(N+1);i++)
			A[i][i+(N+1)]=A[i+(N+1)][i]=-1;

		for(int i=0;i<(N+1)*(N+1);i++)
		{	Flag[i][0]=2;
			Flag[i][1]=0;
		}
		mod_Flag(N*(N+2)/2);
		drawBed(N*(N+2)/2,1);
	}

	private void choleskyEx(int t)
	{	double[]v=new double[N*(N+2)-t];
		double[]g=new double[N*(N+2)-t];
		double[][]B=new double[N*(N+2)-t][N*(N+2)-t];
		int no=0,no_=0;
		int[]ord=new int[TL+1];

		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(Flag[i][0]==0)
			{	ord[no]=i;no++;
			}
		}
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
				no++;
			else
			{	g[i-no]=f[i];
				no_=0;
				for(int j=0;j<i;j++)
				{	if(j==ord[no_])
						no_++;
					else
						B[i-no][j-no_]=B[j-no_][i-no]=A[i][j];
				}
				B[i-no][i-no]=A[i][i];
			}
		}
		v=XAlgebra.cholesky(B,g);
		no=0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	if(i==ord[no])
			{	u[i]=0.0;no++;
			}
			else
				u[i]=v[i-no];
		}
	}

	private void get_u(int t)
	{	f[Nv[No]]=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
		{	A[i][Nv[No]]=0;
			A[Nv[No]][i]=0;
		}
		A[Nv[No]][Nv[No]]=1;
		choleskyEx(t);
		No++;
	}

	private void mod_Flag(int n)
	{	Flag[n][0]=0;
		Nv[No]=n;

		int x=n%(N+1),y=n/(N+1);
		if(x==0)
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else if(x==N)
			if(y==0)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
		else
			if(y==0)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
			}
			else if(y==N)
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n-(N+1),n);
			}
			else
			{	mod_Flag2(n+1,n);
				mod_Flag2(n-1,n);
				mod_Flag2(n+(N+1),n);
				mod_Flag2(n-(N+1),n);
			}
	}

	private void mod_Flag2(int n,int n_)
	{	if(Flag[n][0]==2)
		{	Flag[n][0]=1;
			Flag[n][1]=n_;
		}
	}

	private void sort(int t)
	{	int no=0;
		double max=0.0;
		double[]uu=new double[(N+1)*(N+1)];

		for(int i=0;i<(N+1)*(N+1);i++)
			uu[i]=u[i]*rd[i];

		max=0.0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==1)
				if(uu[i]>max)
				{	max=uu[i];
					no=i;
				}

		mod_Flag(no);
		draw(no,Flag[no][1],t);
	}

	private void draw(int n,int n_,int t)
	{	drawBed(n,3);
		int x=n%(N+1),y=n/(N+1);
		int x_=n_%(N+1),y_=n_/(N+1);
		int w=XMath.fint(w_max-(w_max-w_min)*t/TL);
		XG.line(-FR+XMath.fint((2*x+1)*d),-FR+XMath.fint((2*y+1)*d),
				-FR+XMath.fint((2*x_+1)*d),-FR+XMath.fint((2*y_+1)*d),XColor.Color16[1],w);
	}

	private void drawBed(int n,int col)
	{	int x=n%(N+1),y=n/(N+1);
		XG.rectangleF(-FR+XMath.fint(2*x*d),-FR+XMath.fint(2*y*d),
					  -FR+XMath.fint(2*(x+1)*d),-FR+XMath.fint(2*(y+1)*d),XColor.Color16[col]);
	}

	private void myPaint()
	{	XTimer tm=new XTimer();
		tm.setTimer();

		XG.set0(FC,1);
		XG.rectangle(-FR-21,FR+21,FR+21,-FR-21,XColor.Color16[0]);
		XG.rectangleF(-FR,FR,FR,-FR,XColor.Color16[2]);

		init();
		for(int t=0;t<TL;t++)
		{	get_u(t);
			sort(t);
		}

		int Tot=0;
		for(int i=0;i<(N+1)*(N+1);i++)
			if(Flag[i][0]==0)
				Tot++;

		XG.string(10,140,"N="+N,XColor.Color16[0],16);
		XG.string(10,160,"(N+1)*(N+1)="+(N+1)*(N+1),XColor.Color16[0],16);
		XG.string(10,180,"h="+XMath.fdouble(h,5),XColor.Color16[0],16);
		XG.string(10,200,"d="+XMath.fint(d),XColor.Color16[0],16);
		XG.string(10,220,"TL="+TL,XColor.Color16[0],16);
		XG.string(10,240,"dr="+dr,XColor.Color16[0],16);
		XG.string(10,300,"No="+No,XColor.Color16[0],16);
		XG.string(10,320,"Nv[0]="+Nv[0],XColor.Color16[0],16);
		XG.string(10,340,"Nv["+(No-1)+"]="+Nv[No-1],XColor.Color16[0],16);
		XG.string(10,700,"Tot="+Tot,XColor.Color16[0],16);
		tm.getTimer();
		XG.string(10,720,"Time="+tm.Time,XColor.Color16[0],16);
	}

	public F0608c()
	{	super();
		initFrame(1024,768,XColor.Color16[7],"͓`fɂlbg[Np^[");
		Container cp=getContentPane();
		cp.setBackground(getBackground());
		cp.setLayout(new FlowLayout(FlowLayout.LEFT));
		JPanel pn=new JPanel();
		pn.setLayout(new GridLayout(file.length,1));
		for(int i=0;i<file.length;i++)
		{	bt[i]=new JButton(file[i]);
			bt[i].addActionListener(this);
			pn.add(bt[i]);
		}
		cp.add(pn);
		setVisible(true);
		XG=new XGraphics(getGraphics());
	}

	public static void main(String[]argv)
	{	F0608c app=new F0608c();
	}

	public void actionPerformed(ActionEvent evt)
	{	if(evt.getSource()==bt[0])
			myPaint();
		if(evt.getSource()==bt[1])
			repaint();
		if(evt.getSource()==bt[2])
		{	dispose();
			System.exit(0);
		}
	}
}