// XAnalysisF͊wNX

package xxx;

public final class XAnalysis
{	// U(1ϐ2)
	public static double[][]divergence(double[][]u,int N,double dx,double dy)
	{	double[][]s=new double[N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	if(nx==0)
					if(ny==0)
						s[nx][ny]=u[nx+1][ny]+u[nx][ny+1]-2*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=u[nx+1][ny]+u[nx][ny-1]-2*u[nx][ny];
					else
						s[nx][ny]=u[nx+1][ny]+u[nx][ny+1]+u[nx][ny-1]-3*u[nx][ny];
				else if(nx==N)
					if(ny==0)
						s[nx][ny]=u[nx-1][ny]+u[nx][ny+1]-2*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=u[nx-1][ny]+u[nx][ny-1]-2*u[nx][ny];
					else
						s[nx][ny]=u[nx-1][ny]+u[nx][ny+1]+u[nx][ny-1]-3*u[nx][ny];
				else
					if(ny==0)
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+u[nx][ny+1]-3*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+u[nx][ny-1]-3*u[nx][ny];
					else
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+u[nx][ny+1]+u[nx][ny-1]-4*u[nx][ny];
				s[nx][ny]=s[nx][ny]/(dx*dx);
			}
		return s;
	}
	// U(1ϐ2)
	public static double[][]divergenceQ(double[][]u,int N,double dx,double dy)
	{	double[][]s=new double[N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	if(nx==0)
					if(ny==0)
						s[nx][ny]=2*u[nx+1][ny]+2*u[nx][ny+1]-4*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=2*u[nx+1][ny]+u[nx][ny-1]-3*u[nx][ny];
					else
						s[nx][ny]=2*u[nx+1][ny]+u[nx][ny+1]+u[nx][ny-1]-4*u[nx][ny];
				else if(nx==N)
					if(ny==0)
						s[nx][ny]=u[nx-1][ny]+2*u[nx][ny+1]-3*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=u[nx-1][ny]+u[nx][ny-1]-2*u[nx][ny];
					else
						s[nx][ny]=u[nx-1][ny]+u[nx][ny+1]+u[nx][ny-1]-3*u[nx][ny];
				else
					if(ny==0)
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+2*u[nx][ny+1]-4*u[nx][ny];
					else if(ny==N)
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+u[nx][ny-1]-3*u[nx][ny];
					else
						s[nx][ny]=u[nx+1][ny]+u[nx-1][ny]+u[nx][ny+1]+u[nx][ny-1]-4*u[nx][ny];
				s[nx][ny]=s[nx][ny]/(4*dx*dx);
			}
		return s;
	}
	// U(2ϐ2)
	public static double[][][]divergence(double[][]u0,double[][]u1,int N,double dx,double dy)
	{	double[][][]s=new double[2][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	double s0=0.0,s1=0.0;
				if(nx==0)
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx][ny+1]-2*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny+1]-2*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
					}
				else if(nx==N)
					if(ny==0)
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]-2*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx-1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
					}
					else
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
					}
				else
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]-3*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
					}
				s[0][nx][ny]=s0/(dx*dx);
				s[1][nx][ny]=s1/(dy*dy);
			}
		return s;
	}
	// U(2ϐ2)
	public static double[][][]divergenceQ(double[][]u0,double[][]u1,int N,double dx,double dy)
	{	double[][][]s=new double[2][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	double s0=0.0,s1=0.0;
				if(nx==0)
					if(ny==0)
					{	s0=2*u0[nx+1][ny]+2*u0[nx][ny+1]-4*u0[nx][ny];
						s1=2*u1[nx+1][ny]+2*u1[nx][ny+1]-4*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=2*u0[nx+1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=2*u1[nx+1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
					}
					else
					{	s0=2*u0[nx+1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=2*u1[nx+1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
					}
				else if(nx==N)
					if(ny==0)
					{	s0=u0[nx-1][ny]+2*u0[nx][ny+1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+2*u1[nx][ny+1]-3*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx-1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
					}
					else
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
					}
				else
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+2*u0[nx][ny+1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+2*u1[nx][ny+1]-4*u1[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
					}
				s[0][nx][ny]=s0/(4*dx*dx);
				s[1][nx][ny]=s1/(4*dy*dy);
			}
		return s;
	}
	// U(3ϐ2)
	public static double[][][]divergence(double[][]u0,double[][]u1,double[][]u2,int N,double dx,double dy)
	{	double[][][]s=new double[3][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	double s0=0.0,s1=0.0,s2=0.0;
				if(nx==0)
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx][ny+1]-2*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny+1]-2*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx][ny+1]-2*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx][ny-1]-2*u2[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-3*u2[nx][ny];
					}
				else if(nx==N)
					if(ny==0)
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]-2*u1[nx][ny];
						s2=u2[nx-1][ny]+u2[nx][ny+1]-2*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx-1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
						s2=u2[nx-1][ny]+u2[nx][ny-1]-2*u2[nx][ny];
					}
					else
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=u2[nx-1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-3*u2[nx][ny];
					}
				else
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]-3*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+u2[nx][ny+1]-3*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+u2[nx][ny-1]-3*u2[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-4*u2[nx][ny];
					}
				s[0][nx][ny]=s0/(dx*dx);
				s[1][nx][ny]=s1/(dy*dy);
				s[2][nx][ny]=s2/(dy*dy);
			}
		return s;
	}
	// U(3ϐ2)
	public static double[][][]divergenceQ(double[][]u0,double[][]u1,double[][]u2,int N,double dx,double dy)
	{	double[][][]s=new double[3][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
			for(int ny=0;ny<=N;ny++)
			{	double s0=0.0,s1=0.0,s2=0.0;
				if(nx==0)
					if(ny==0)
					{	s0=2*u0[nx+1][ny]+2*u0[nx][ny+1]-4*u0[nx][ny];
						s1=2*u1[nx+1][ny]+2*u1[nx][ny+1]-4*u1[nx][ny];
						s2=2*u2[nx+1][ny]+2*u2[nx][ny+1]-4*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=2*u0[nx+1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=2*u1[nx+1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=2*u2[nx+1][ny]+u2[nx][ny-1]-3*u2[nx][ny];
					}
					else
					{	s0=2*u0[nx+1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=2*u1[nx+1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
						s2=2*u2[nx+1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-4*u2[nx][ny];
					}
				else if(nx==N)
					if(ny==0)
					{	s0=u0[nx-1][ny]+2*u0[nx][ny+1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+2*u1[nx][ny+1]-3*u1[nx][ny];
						s2=u2[nx-1][ny]+2*u2[nx][ny+1]-3*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx-1][ny]+u0[nx][ny-1]-2*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny-1]-2*u1[nx][ny];
						s2=u2[nx-1][ny]+u2[nx][ny-1]-2*u2[nx][ny];
					}
					else
					{	s0=u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=u2[nx-1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-3*u2[nx][ny];
					}
				else
					if(ny==0)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+2*u0[nx][ny+1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+2*u1[nx][ny+1]-4*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+2*u2[nx][ny+1]-4*u2[nx][ny];
					}
					else if(ny==N)
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny-1]-3*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny-1]-3*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+u2[nx][ny-1]-3*u2[nx][ny];
					}
					else
					{	s0=u0[nx+1][ny]+u0[nx-1][ny]+u0[nx][ny+1]+u0[nx][ny-1]-4*u0[nx][ny];
						s1=u1[nx+1][ny]+u1[nx-1][ny]+u1[nx][ny+1]+u1[nx][ny-1]-4*u1[nx][ny];
						s2=u2[nx+1][ny]+u2[nx-1][ny]+u2[nx][ny+1]+u2[nx][ny-1]-4*u2[nx][ny];
					}
				s[0][nx][ny]=s0/(4*dx*dx);
				s[1][nx][ny]=s1/(4*dy*dy);
				s[2][nx][ny]=s2/(4*dy*dy);
			}
		return s;
	}
	// U(ϐ2)
	public static double[][][]divergence(double[][][]u,int N,double dx,double dy)
	{	double[][][]s=new double[u.length][N+1][N+1];
		for(int n=0;n<u.length;n++)
			for(int nx=0;nx<=N;nx++)
				for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						if(ny==0)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx][ny+1]-2*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx][ny-1]-2*u[n][nx][ny];
						else
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-3*u[n][nx][ny];
					else if(nx==N)
						if(ny==0)
							s[n][nx][ny]=u[n][nx-1][ny]+u[n][nx][ny+1]-2*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=u[n][nx-1][ny]+u[n][nx][ny-1]-2*u[n][nx][ny];
						else
							s[n][nx][ny]=u[n][nx-1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-3*u[n][nx][ny];
					else
						if(ny==0)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+u[n][nx][ny+1]-3*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+u[n][nx][ny-1]-3*u[n][nx][ny];
						else
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-4*u[n][nx][ny];
					s[n][nx][ny]=s[n][nx][ny]/(dx*dx);
				}
		return s;
	}
	// U(ϐ2)
	public static double[][][]divergenceQ(double[][][]u,int N,double dx,double dy)
	{	double[][][]s=new double[u.length][N+1][N+1];
		for(int n=0;n<u.length;n++)
			for(int nx=0;nx<=N;nx++)
				for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						if(ny==0)
							s[n][nx][ny]=2*u[n][nx+1][ny]+2*u[n][nx][ny+1]-4*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=2*u[n][nx+1][ny]+u[n][nx][ny-1]-3*u[n][nx][ny];
						else
							s[n][nx][ny]=2*u[n][nx+1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-4*u[n][nx][ny];
					else if(nx==N)
						if(ny==0)
							s[n][nx][ny]=u[n][nx-1][ny]+2*u[n][nx][ny+1]-3*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=u[n][nx-1][ny]+u[n][nx][ny-1]-2*u[n][nx][ny];
						else
							s[n][nx][ny]=u[n][nx-1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-3*u[n][nx][ny];
					else
						if(ny==0)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+2*u[n][nx][ny+1]-4*u[n][nx][ny];
						else if(ny==N)
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+u[n][nx][ny-1]-3*u[n][nx][ny];
						else
							s[n][nx][ny]=u[n][nx+1][ny]+u[n][nx-1][ny]+u[n][nx][ny+1]+u[n][nx][ny-1]-4*u[n][nx][ny];
					s[n][nx][ny]=s[n][nx][ny]/(4*dx*dx);
				}
		return s;
	}
	// Δ(1ϐ1)...Zero-flux
	public static double[][]pDiffS(double[]u,int N,double dx)
	{	double[][]w=new double[3][N+1];
		for(int n=0;n<=N;n++)
			w[0][n]=u[n];
			for(int n=0;n<=N;n++)
		{	if(n==0||n==N)
				w[1][n]=0.0;
			else
				w[1][n]
			=(w[0][n+1]-w[0][n-1])/(2*dx);
		}
		for(int n=0;n<=N;n++)
		{	if(n==0)
				w[2][n]
			=2*(w[0][1]-w[0][0])/(dx*dx);
			else if(n==N)
				w[2][n]
			=2*(w[0][N-1]-w[0][N])/(dx*dx);
			else
				w[2][n]
			=(w[0][n+1]-2*w[0][n]
			+w[0][n-1])/(dx*dx);
		}
		return w;
	}
	// Δ(1ϐ2)...Zero-flux
	public static double[][][]pDiffS(double[][]u,int N,double dx,double dy)
	{	double[][][]w=new double[5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[0][nx][ny]=u[nx][ny];
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(nx==0||nx==N)
					w[1][nx][ny]=0.0;
				else
					w[1][nx][ny]
				=(w[0][nx+1][ny]-w[0][nx-1][ny])/(2*dx);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(nx==0)
					w[2][nx][ny]
				=2*(w[0][1][ny]-w[0][0][ny])/(dx*dx);
				else if(nx==N)
					w[2][nx][ny]
				=2*(w[0][N-1][ny]-w[0][N][ny])/(dx*dx);
				else
					w[2][nx][ny]
				=(w[0][nx+1][ny]-2*w[0][nx][ny]
				+w[0][nx-1][ny])/(dx*dx);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(ny==0||ny==N)
					w[3][nx][ny]=0.0;
				else
					w[3][nx][ny]
				=(w[0][nx][ny+1]-w[0][nx][ny-1])/(2*dy);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(ny==0)
					w[4][nx][ny]
				=2*(w[0][nx][1]-w[0][nx][0])/(dy*dy);
				else if(ny==N)
					w[4][nx][ny]
				=2*(w[0][nx][N-1]-w[0][nx][N])/(dy*dy);
				else
					w[4][nx][ny]
				=(w[0][nx][ny+1]-2*w[0][nx][ny]
				+w[0][nx][ny-1])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(2ϐ1)...Zero-flux
	public static double[][][]pDiffS(double[]u0,double[]u1,
		int N,double dx)
	{	double[][][]w=new double[2][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
		}
		for(int i=0;i<2;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0||n==N)
					w[i][1][n]=0.0;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=2*(w[i][0][1]-w[i][0][0])/(dx*dx);
				else if(n==N)
					w[i][2][n]
				=2*(w[i][0][N-1]-w[i][0][N])/(dx*dx);
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(2ϐ2)...Zero-flux
	public static double[][][][]pDiffS(double[][]u0,double[][]u1,
		int N,double dx,double dy)
	{	double[][][][]w=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
			}
		}
		for(int i=0;i<2;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0||nx==N)
						w[i][1][nx][ny]=0.0;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=2*(w[i][0][1][ny]-w[i][0][0][ny])/(dx*dx);
					else if(nx==N)
						w[i][2][nx][ny]
					=2*(w[i][0][N-1][ny]-w[i][0][N][ny])/(dx*dx);
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0||ny==N)
						w[i][3][nx][ny]=0.0;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][1]-w[i][0][nx][0])/(dy*dy);
					else if(ny==N)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][N-1]-w[i][0][nx][N])/(dy*dy);
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(3ϐ1)...Zero-flux
	public static double[][][]pDiffS(double[]u0,double[]u1,
		double[]u2,int N,double dx)
	{	double[][][]w=new double[3][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
		}
		for(int i=0;i<3;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0||n==N)
					w[i][1][n]=0.0;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=2*(w[i][0][1]-w[i][0][0])/(dx*dx);
				else if(n==N)
					w[i][2][n]
				=2*(w[i][0][N-1]-w[i][0][N])/(dx*dx);
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(3ϐ2)...Zero-flux
	public static double[][][][]pDiffS(double[][]u0,double[][]u1,
		double[][]u2,int N,double dx,double dy)
	{	double[][][][]w=new double[3][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
			}
		}
		for(int i=0;i<3;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0||nx==N)
						w[i][1][nx][ny]=0.0;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=2*(w[i][0][1][ny]-w[i][0][0][ny])/(dx*dx);
					else if(nx==N)
						w[i][2][nx][ny]
					=2*(w[i][0][N-1][ny]-w[i][0][N][ny])/(dx*dx);
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0||ny==N)
						w[i][3][nx][ny]=0.0;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][1]-w[i][0][nx][0])/(dy*dy);
					else if(ny==N)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][N-1]-w[i][0][nx][N])/(dy*dy);
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(4ϐ1)...Zero-flux
	public static double[][][]pDiffS(double[]u0,double[]u1,
		double[]u2,double[]u3,int N,double dx)
	{	double[][][]w=new double[4][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
		}
		for(int i=0;i<4;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0||n==N)
					w[i][1][n]=0.0;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=2*(w[i][0][1]-w[i][0][0])/(dx*dx);
				else if(n==N)
					w[i][2][n]
				=2*(w[i][0][N-1]-w[i][0][N])/(dx*dx);
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(4ϐ2)...Zero-flux
	public static double[][][][]pDiffS(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,int N,double dx,double dy)
	{	double[][][][]w=new double[4][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
			}
		}
		for(int i=0;i<4;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0||nx==N)
						w[i][1][nx][ny]=0.0;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=2*(w[i][0][1][ny]-w[i][0][0][ny])/(dx*dx);
					else if(nx==N)
						w[i][2][nx][ny]
					=2*(w[i][0][N-1][ny]-w[i][0][N][ny])/(dx*dx);
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0||ny==N)
						w[i][3][nx][ny]=0.0;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][1]-w[i][0][nx][0])/(dy*dy);
					else if(ny==N)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][N-1]-w[i][0][nx][N])/(dy*dy);
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(5ϐ1)...Zero-flux
	public static double[][][]pDiffS(double[]u0,double[]u1,
		double[]u2,double[]u3,double[]u4,int N,double dx)
	{	double[][][]w=new double[5][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
			w[4][0][n]=u4[n];
		}
		for(int i=0;i<5;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0||n==N)
					w[i][1][n]=0.0;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=2*(w[i][0][1]-w[i][0][0])/(dx*dx);
				else if(n==N)
					w[i][2][n]
				=2*(w[i][0][N-1]-w[i][0][N])/(dx*dx);
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(5ϐ2)...Zero-flux
	public static double[][][][]pDiffS(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,double[][]u4,int N,double dx,double dy)
	{	double[][][][]w=new double[5][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
				w[4][0][nx][ny]=u4[nx][ny];
			}
		}
		for(int i=0;i<5;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0||nx==N)
						w[i][1][nx][ny]=0.0;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=2*(w[i][0][1][ny]-w[i][0][0][ny])/(dx*dx);
					else if(nx==N)
						w[i][2][nx][ny]
					=2*(w[i][0][N-1][ny]-w[i][0][N][ny])/(dx*dx);
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0||ny==N)
						w[i][3][nx][ny]=0.0;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][1]-w[i][0][nx][0])/(dy*dy);
					else if(ny==N)
						w[i][4][nx][ny]
					=2*(w[i][0][nx][N-1]-w[i][0][nx][N])/(dy*dy);
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(1ϐ1)...Periodic
	public static double[][]pDiffP(double[]u,int N,double dx)
	{	double[][]w=new double[3][N+1];
		for(int n=0;n<=N;n++)
			w[0][n]=u[n%N];
		for(int n=0;n<=N;n++)
			w[1][n]
		=(w[0][(n+1)%N]-w[0][(n+N-1)%N])/(2*dx);
		for(int n=0;n<=N;n++)
			w[2][n]
		=(w[0][(n+1)%N]-2*w[0][n]
		+w[0][(n+N-1)%N])/(dx*dx);
		return w;
	}
	// Δ(1ϐ2)...Periodic
	public static double[][][]pDiffP(double[][]u,int N,double dx,double dy)
	{	double[][][]w=new double[5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[0][nx][ny]=u[nx%N][ny%N];
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[1][nx][ny]
			=(w[0][(nx+1)%N][ny]-w[0][(nx+N-1)%N][ny])/(2*dx);
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[2][nx][ny]
			=(w[0][(nx+1)%N][ny]-2*w[0][nx][ny]
			+w[0][(nx+N-1)%N][ny])/(dx*dx);
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[3][nx][ny]
			=(w[0][nx][(ny+1)%N]-w[0][nx][(ny+N-1)%N])/(2*dy);
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[4][nx][ny]
			=(w[0][nx][(ny+1)%N]-2*w[0][nx][ny]
			+w[0][nx][(ny+N-1)%N])/(dy*dy);
		}
		return w;
	}
	// Δ(2ϐ1)...Periodic
	public static double[][][]pDiffP(double[]u0,double[]u1,
		int N,double dx)
	{	double[][][]w=new double[2][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n%N];
			w[1][0][n]=u1[n%N];
		}
		for(int i=0;i<2;i++)
		{	for(int n=0;n<=N;n++)
				w[i][1][n]
			=(w[i][0][(n+1)%N]-w[i][0][(n+N-1)%N])/(2*dx);
			for(int n=0;n<=N;n++)
				w[i][2][n]
			=(w[i][0][(n+1)%N]-2*w[i][0][n]
			+w[i][0][(n+N-1)%N])/(dx*dx);
		}
		return w;
	}
	// Δ(2ϐ2)...Periodic
	public static double[][][][]pDiffP(double[][]u0,double[][]u1,
		int N,double dx,double dy)
	{	double[][][][]w=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx%N][ny%N];
				w[1][0][nx][ny]=u1[nx%N][ny%N];
			}
		}
		for(int i=0;i<2;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][1][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-w[i][0][(nx+N-1)%N][ny])/(2*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][2][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-2*w[i][0][nx][ny]
				+w[i][0][(nx+N-1)%N][ny])/(dx*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][3][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-w[i][0][nx][(ny+N-1)%N])/(2*dy);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][4][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-2*w[i][0][nx][ny]
				+w[i][0][nx][(ny+N-1)%N])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(3ϐ1)...Periodic
	public static double[][][]pDiffP(double[]u0,double[]u1,
		double[]u2,int N,double dx)
	{	double[][][]w=new double[3][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n%N];
			w[1][0][n]=u1[n%N];
			w[2][0][n]=u2[n%N];
		}
		for(int i=0;i<3;i++)
		{	for(int n=0;n<=N;n++)
				w[i][1][n]
			=(w[i][0][(n+1)%N]-w[i][0][(n+N-1)%N])/(2*dx);
			for(int n=0;n<=N;n++)
				w[i][2][n]
			=(w[i][0][(n+1)%N]-2*w[i][0][n]
			+w[i][0][(n+N-1)%N])/(dx*dx);
		}
		return w;
	}
	// Δ(3ϐ2)...Periodic
	public static double[][][][]pDiffP(double[][]u0,double[][]u1,
		double[][]u2,int N,double dx,double dy)
	{	double[][][][]w=new double[3][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx%N][ny%N];
				w[1][0][nx][ny]=u1[nx%N][ny%N];
				w[2][0][nx][ny]=u2[nx%N][ny%N];
			}
		}
		for(int i=0;i<3;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][1][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-w[i][0][(nx+N-1)%N][ny])/(2*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][2][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-2*w[i][0][nx][ny]
				+w[i][0][(nx+N-1)%N][ny])/(dx*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][3][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-w[i][0][nx][(ny+N-1)%N])/(2*dy);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][4][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-2*w[i][0][nx][ny]
				+w[i][0][nx][(ny+N-1)%N])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(4ϐ1)...Periodic
	public static double[][][]pDiffP(double[]u0,double[]u1,
		double[]u2,double[]u3,int N,double dx)
	{	double[][][]w=new double[4][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n%N];
			w[1][0][n]=u1[n%N];
			w[2][0][n]=u2[n%N];
			w[3][0][n]=u3[n%N];
		}
		for(int i=0;i<4;i++)
		{	for(int n=0;n<=N;n++)
				w[i][1][n]
			=(w[i][0][(n+1)%N]-w[i][0][(n+N-1)%N])/(2*dx);
			for(int n=0;n<=N;n++)
				w[i][2][n]
			=(w[i][0][(n+1)%N]-2*w[i][0][n]
			+w[i][0][(n+N-1)%N])/(dx*dx);
		}
		return w;
	}
	// Δ(4ϐ2)...Periodic
	public static double[][][][]pDiffP(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,int N,double dx,double dy)
	{	double[][][][]w=new double[4][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx%N][ny%N];
				w[1][0][nx][ny]=u1[nx%N][ny%N];
				w[2][0][nx][ny]=u2[nx%N][ny%N];
				w[3][0][nx][ny]=u3[nx%N][ny%N];
			}
		}
		for(int i=0;i<4;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][1][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-w[i][0][(nx+N-1)%N][ny])/(2*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][2][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-2*w[i][0][nx][ny]
				+w[i][0][(nx+N-1)%N][ny])/(dx*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][3][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-w[i][0][nx][(ny+N-1)%N])/(2*dy);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][4][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-2*w[i][0][nx][ny]
				+w[i][0][nx][(ny+N-1)%N])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(5ϐ1)...Periodic
	public static double[][][]pDiffP(double[]u0,double[]u1,
		double[]u2,double[]u3,double[]u4,int N,double dx)
	{	double[][][]w=new double[5][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n%N];
			w[1][0][n]=u1[n%N];
			w[2][0][n]=u2[n%N];
			w[3][0][n]=u3[n%N];
			w[4][0][n]=u4[n%N];
		}
		for(int i=0;i<5;i++)
		{	for(int n=0;n<=N;n++)
				w[i][1][n]
			=(w[i][0][(n+1)%N]-w[i][0][(n+N-1)%N])/(2*dx);
			for(int n=0;n<=N;n++)
				w[i][2][n]
			=(w[i][0][(n+1)%N]-2*w[i][0][n]
			+w[i][0][(n+N-1)%N])/(dx*dx);
		}
		return w;
	}
	// Δ(5ϐ2)...Periodic
	public static double[][][][]pDiffP(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,double[][]u4,int N,double dx,double dy)
	{	double[][][][]w=new double[5][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx%N][ny%N];
				w[1][0][nx][ny]=u1[nx%N][ny%N];
				w[2][0][nx][ny]=u2[nx%N][ny%N];
				w[3][0][nx][ny]=u3[nx%N][ny%N];
				w[4][0][nx][ny]=u4[nx%N][ny%N];
			}
		}
		for(int i=0;i<5;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][1][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-w[i][0][(nx+N-1)%N][ny])/(2*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][2][nx][ny]
				=(w[i][0][(nx+1)%N][ny]-2*w[i][0][nx][ny]
				+w[i][0][(nx+N-1)%N][ny])/(dx*dx);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][3][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-w[i][0][nx][(ny+N-1)%N])/(2*dy);
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
					w[i][4][nx][ny]
				=(w[i][0][nx][(ny+1)%N]-2*w[i][0][nx][ny]
				+w[i][0][nx][(ny+N-1)%N])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(1ϐ1)...Original(1)
	public static double[][]pDiff(double[]u,int N,double dx)
	{	double[][]w=new double[3][N+1];
		for(int n=0;n<=N;n++)
			w[0][n]=u[n];
		for(int n=0;n<=N;n++)
		{	if(n==0)
				w[1][n]
			=(w[0][n+1]-w[0][n])/dx;
			else if(n==N)
				w[1][n]
			=(w[0][n]-w[0][n-1])/dx;
			else
				w[1][n]
			=(w[0][n+1]-w[0][n-1])/(2*dx);
		}
		for(int n=0;n<=N;n++)
		{	if(n==0)
				w[2][n]
			=(w[1][n+1]-w[1][n])/dx;
			else if(n==N)
				w[2][n]
			=(w[1][n]-w[1][n-1])/dx;
			else
				w[2][n]
			=(w[0][n+1]-2*w[0][n]
			+w[0][n-1])/(dx*dx);
		}
		return w;
	}
	// Δ(1ϐ2)...Original(1)
	public static double[][][]pDiff(double[][]u,int N,double dx,double dy)
	{	double[][][]w=new double[5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[0][nx][ny]=u[nx][ny];
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(nx==0)
					w[1][nx][ny]
				=(w[0][nx+1][ny]-w[0][nx][ny])/dx;
				else if(nx==N)
					w[1][nx][ny]
				=(w[0][nx][ny]-w[0][nx-1][ny])/dx;
				else
					w[1][nx][ny]
				=(w[0][nx+1][ny]-w[0][nx-1][ny])/(2*dx);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(nx==0)
					w[2][nx][ny]
				=(w[1][nx+1][ny]-w[1][nx][ny])/dx;
				else if(nx==N)
					w[2][nx][ny]
				=(w[1][nx][ny]-w[1][nx-1][ny])/dx;
				else
					w[2][nx][ny]
				=(w[0][nx+1][ny]-2*w[0][nx][ny]
				+w[0][nx-1][ny])/(dx*dx);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(ny==0)
					w[3][nx][ny]
				=(w[0][nx][ny+1]-w[0][nx][ny])/dy;
				else if(ny==N)
					w[3][nx][ny]
				=(w[0][nx][ny]-w[0][nx][ny-1])/dy;
				else
					w[3][nx][ny]
				=(w[0][nx][ny+1]-w[0][nx][ny-1])/(2*dy);
			}
		}
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	if(ny==0)
					w[4][nx][ny]
				=(w[3][nx][ny+1]-w[3][nx][ny])/dy;
				else if(ny==N)
					w[4][nx][ny]
				=(w[3][nx][ny]-w[3][nx][ny-1])/dy;
				else
					w[4][nx][ny]
				=(w[0][nx][ny+1]-2*w[0][nx][ny]
				+w[0][nx][ny-1])/(dy*dy);
			}
		}
		return w;
	}
	// Δ(2ϐ1)...Original(1)
	public static double[][][]pDiff(double[]u0,double[]u1,
		int N,double dx)
	{	double[][][]w=new double[2][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
		}
		for(int i=0;i<2;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n])/dx;
				else if(n==N)
					w[i][1][n]
				=(w[i][0][n]-w[i][0][n-1])/dx;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=(w[i][1][n+1]-w[i][1][n])/dx;
				else if(n==N)
					w[i][2][n]
				=(w[i][1][n]-w[i][1][n-1])/dx;
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(2ϐ2)...Original(1)
	public static double[][][][]pDiff(double[][]u0,double[][]u1,
		int N,double dx,double dy)
	{	double[][][][]w=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
			}
		}
		for(int i=0;i<2;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx][ny])/dx;
					else if(nx==N)
						w[i][1][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx-1][ny])/dx;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=(w[i][1][nx+1][ny]-w[i][1][nx][ny])/dx;
					else if(nx==N)
						w[i][2][nx][ny]
					=(w[i][1][nx][ny]-w[i][1][nx-1][ny])/dx;
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny])/dy;
					else if(ny==N)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx][ny-1])/dy;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny+1]-w[i][3][nx][ny])/dy;
					else if(ny==N)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny]-w[i][3][nx][ny-1])/dy;
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(3ϐ1)...Original(1)
	public static double[][][]pDiff(double[]u0,double[]u1,
		double[]u2,int N,double dx)
	{	double[][][]w=new double[3][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
		}
		for(int i=0;i<3;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n])/dx;
				else if(n==N)
					w[i][1][n]
				=(w[i][0][n]-w[i][0][n-1])/dx;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=(w[i][1][n+1]-w[i][1][n])/dx;
				else if(n==N)
					w[i][2][n]
				=(w[i][1][n]-w[i][1][n-1])/dx;
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(3ϐ2)...Original(1)
	public static double[][][][]pDiff(double[][]u0,double[][]u1,
		double[][]u2,int N,double dx,double dy)
	{	double[][][][]w=new double[3][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
			}
		}
		for(int i=0;i<3;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx][ny])/dx;
					else if(nx==N)
						w[i][1][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx-1][ny])/dx;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=(w[i][1][nx+1][ny]-w[i][1][nx][ny])/dx;
					else if(nx==N)
						w[i][2][nx][ny]
					=(w[i][1][nx][ny]-w[i][1][nx-1][ny])/dx;
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny])/dy;
					else if(ny==N)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx][ny-1])/dy;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny+1]-w[i][3][nx][ny])/dy;
					else if(ny==N)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny]-w[i][3][nx][ny-1])/dy;
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(4ϐ1)...Original(1)
	public static double[][][]pDiff(double[]u0,double[]u1,
		double[]u2,double[]u3,int N,double dx)
	{	double[][][]w=new double[4][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
		}
		for(int i=0;i<4;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n])/dx;
				else if(n==N)
					w[i][1][n]
				=(w[i][0][n]-w[i][0][n-1])/dx;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=(w[i][1][n+1]-w[i][1][n])/dx;
				else if(n==N)
					w[i][2][n]
				=(w[i][1][n]-w[i][1][n-1])/dx;
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(4ϐ2)...Original(1)
	public static double[][][][]pDiff(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,int N,double dx,double dy)
	{	double[][][][]w=new double[4][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
			}
		}
		for(int i=0;i<4;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx][ny])/dx;
					else if(nx==N)
						w[i][1][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx-1][ny])/dx;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=(w[i][1][nx+1][ny]-w[i][1][nx][ny])/dx;
					else if(nx==N)
						w[i][2][nx][ny]
					=(w[i][1][nx][ny]-w[i][1][nx-1][ny])/dx;
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny])/dy;
					else if(ny==N)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx][ny-1])/dy;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny+1]-w[i][3][nx][ny])/dy;
					else if(ny==N)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny]-w[i][3][nx][ny-1])/dy;
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(5ϐ1)...Original(1)
	public static double[][][]pDiff(double[]u0,double[]u1,
		double[]u2,double[]u3,double[]u4,int N,double dx)
	{	double[][][]w=new double[5][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
			w[4][0][n]=u4[n];
		}
		for(int i=0;i<5;i++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n])/dx;
				else if(n==N)
					w[i][1][n]
				=(w[i][0][n]-w[i][0][n-1])/dx;
				else
					w[i][1][n]
				=(w[i][0][n+1]-w[i][0][n-1])/(2*dx);
			}
			for(int n=0;n<=N;n++)
			{	if(n==0)
					w[i][2][n]
				=(w[i][1][n+1]-w[i][1][n])/dx;
				else if(n==N)
					w[i][2][n]
				=(w[i][1][n]-w[i][1][n-1])/dx;
				else
					w[i][2][n]
				=(w[i][0][n+1]-2*w[i][0][n]
				+w[i][0][n-1])/(dx*dx);
			}
		}
		return w;
	}
	// Δ(5ϐ2)...Original(1)
	public static double[][][][]pDiff(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,double[][]u4,int N,double dx,double dy)
	{	double[][][][]w=new double[5][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
				w[4][0][nx][ny]=u4[nx][ny];
			}
		}
		for(int i=0;i<5;i++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx][ny])/dx;
					else if(nx==N)
						w[i][1][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx-1][ny])/dx;
					else
						w[i][1][nx][ny]
					=(w[i][0][nx+1][ny]-w[i][0][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[i][2][nx][ny]
					=(w[i][1][nx+1][ny]-w[i][1][nx][ny])/dx;
					else if(nx==N)
						w[i][2][nx][ny]
					=(w[i][1][nx][ny]-w[i][1][nx-1][ny])/dx;
					else
						w[i][2][nx][ny]
					=(w[i][0][nx+1][ny]-2*w[i][0][nx][ny]
					+w[i][0][nx-1][ny])/(dx*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny])/dy;
					else if(ny==N)
						w[i][3][nx][ny]
					=(w[i][0][nx][ny]-w[i][0][nx][ny-1])/dy;
					else
						w[i][3][nx][ny]
					=(w[i][0][nx][ny+1]-w[i][0][nx][ny-1])/(2*dy);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny+1]-w[i][3][nx][ny])/dy;
					else if(ny==N)
						w[i][4][nx][ny]
					=(w[i][3][nx][ny]-w[i][3][nx][ny-1])/dy;
					else
						w[i][4][nx][ny]
					=(w[i][0][nx][ny+1]-2*w[i][0][nx][ny]
					+w[i][0][nx][ny-1])/(dy*dy);
				}
			}
		}
		return w;
	}
	// Δ(1ϐ1)...Original(2)
	public static double[][]pDiff2(double[]u,int N,double dx)
	{	double[][]w=new double[3][N+1];
		for(int n=0;n<=N;n++)
			w[0][n]=u[n];
		for(int j=0;j<2;j++)
		{	for(int n=0;n<=N;n++)
			{	if(n==0)
					w[j+1][n]
				=(w[j][n+1]-w[j][n])/dx;
				else if(n==N)
					w[j+1][n]
				=(w[j][n]-w[j][n-1])/dx;
				else
					w[j+1][n]
				=(w[j][n+1]-w[j][n-1])/(2*dx);
			}
		}
		return w;
	}
	// Δ(1ϐ2)...Original(2)
	public static double[][][]pDiff2(double[][]u,int N,double dx,double dy)
	{	double[][][]w=new double[5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
				w[0][nx][ny]=u[nx][ny];
		}
		for(int j=0;j<2;j++)
		{	for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(nx==0)
						w[j+1][nx][ny]
					=(w[j][nx+1][ny]-w[j][nx][ny])/dx;
					else if(nx==N)
						w[j+1][nx][ny]
					=(w[j][nx][ny]-w[j][nx-1][ny])/dx;
					else
						w[j+1][nx][ny]
					=(w[j][nx+1][ny]-w[j][nx-1][ny])/(2*dx);
				}
			}
			for(int nx=0;nx<=N;nx++)
			{	for(int ny=0;ny<=N;ny++)
				{	if(ny==0)
						w[j+3][nx][ny]
					=(w[3*j][nx][ny+1]-w[3*j][nx][ny])/dy;
					else if(ny==N)
						w[j+3][nx][ny]
					=(w[3*j][nx][ny]-w[3*j][nx][ny-1])/dy;
					else
						w[j+3][nx][ny]
					=(w[3*j][nx][ny+1]-w[3*j][nx][ny-1])/(2*dy);
				}
			}
		}
		return w;
	}
	// Δ(2ϐ1)...Original(2)
	public static double[][][]pDiff2(double[]u0,double[]u1,
		int N,double dx)
	{	double[][][]w=new double[2][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
		}
		for(int i=0;i<2;i++)
		{	for(int j=0;j<2;j++)
			{	for(int n=0;n<=N;n++)
				{	if(n==0)
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n])/dx;
					else if(n==N)
						w[i][j+1][n]
					=(w[i][j][n]-w[i][j][n-1])/dx;
					else
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n-1])/(2*dx);
				}
			}
		}
		return w;
	}
	// Δ(2ϐ2)...Original(2)
	public static double[][][][]pDiff2(double[][]u0,double[][]u1,
		int N,double dx,double dy)
	{	double[][][][]w=new double[2][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
			}
		}
		for(int i=0;i<2;i++)
		{	for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(nx==0)
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx][ny])/dx;
						else if(nx==N)
							w[i][j+1][nx][ny]
						=(w[i][j][nx][ny]-w[i][j][nx-1][ny])/dx;
						else
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx-1][ny])/(2*dx);
					}
				}
				for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(ny==0)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny])/dy;
						else if(ny==N)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny]-w[i][3*j][nx][ny-1])/dy;
						else
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny-1])/(2*dy);
					}
				}
			}
		}
		return w;
	}
	// Δ(3ϐ1)...Original(2)
	public static double[][][]pDiff2(double[]u0,double[]u1,
		double[]u2,int N,double dx)
	{	double[][][]w=new double[3][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
		}
		for(int i=0;i<3;i++)
		{	for(int j=0;j<2;j++)
			{	for(int n=0;n<=N;n++)
				{	if(n==0)
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n])/dx;
					else if(n==N)
						w[i][j+1][n]
					=(w[i][j][n]-w[i][j][n-1])/dx;
					else
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n-1])/(2*dx);
				}
			}
		}
		return w;
	}
	// Δ(3ϐ2)...Original(2)
	public static double[][][][]pDiff2(double[][]u0,double[][]u1,
		double[][]u2,int N,double dx,double dy)
	{	double[][][][]w=new double[3][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
			}
		}
		for(int i=0;i<3;i++)
		{	for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(nx==0)
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx][ny])/dx;
						else if(nx==N)
							w[i][j+1][nx][ny]
						=(w[i][j][nx][ny]-w[i][j][nx-1][ny])/dx;
						else
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx-1][ny])/(2*dx);
					}
				}
			}
			for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(ny==0)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny])/dy;
						else if(ny==N)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny]-w[i][3*j][nx][ny-1])/dy;
						else
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny-1])/(2*dy);
					}
				}
			}
		}
		return w;
	}
	// Δ(4ϐ1)...Original(2)
	public static double[][][]pDiff2(double[]u0,double[]u1,
		double[]u2,double[]u3,int N,double dx)
	{	double[][][]w=new double[4][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
		}
		for(int i=0;i<4;i++)
		{	for(int j=0;j<2;j++)
			{	for(int n=0;n<=N;n++)
				{	if(n==0)
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n])/dx;
					else if(n==N)
						w[i][j+1][n]
					=(w[i][j][n]-w[i][j][n-1])/dx;
					else
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n-1])/(2*dx);
				}
			}
		}
		return w;
	}
	// Δ(4ϐ2)...Original(2)
	public static double[][][][]pDiff2(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,int N,double dx,double dy)
	{	double[][][][]w=new double[4][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
			}
		}
		for(int i=0;i<4;i++)
		{	for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(nx==0)
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx][ny])/dx;
						else if(nx==N)
							w[i][j+1][nx][ny]
						=(w[i][j][nx][ny]-w[i][j][nx-1][ny])/dx;
						else
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx-1][ny])/(2*dx);
					}
				}
			}
			for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(ny==0)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny])/dy;
						else if(ny==N)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny]-w[i][3*j][nx][ny-1])/dy;
						else
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny-1])/(2*dy);
					}
				}
			}
		}
		return w;
	}
	// Δ(5ϐ1)...Original(2)
	public static double[][][]pDiff2(double[]u0,double[]u1,
		double[]u2,double[]u3,double[]u4,int N,double dx)
	{	double[][][]w=new double[5][3][N+1];
		for(int n=0;n<=N;n++)
		{	w[0][0][n]=u0[n];
			w[1][0][n]=u1[n];
			w[2][0][n]=u2[n];
			w[3][0][n]=u3[n];
			w[4][0][n]=u4[n];
		}
		for(int i=0;i<5;i++)
		{	for(int j=0;j<2;j++)
			{	for(int n=0;n<=N;n++)
				{	if(n==0)
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n])/dx;
					else if(n==N)
						w[i][j+1][n]
					=(w[i][j][n]-w[i][j][n-1])/dx;
					else
						w[i][j+1][n]
					=(w[i][j][n+1]-w[i][j][n-1])/(2*dx);
				}
			}
		}
		return w;
	}
	// Δ(5ϐ2)...Original(2)
	public static double[][][][]pDiff2(double[][]u0,double[][]u1,
		double[][]u2,double[][]u3,double[][]u4,int N,double dx,double dy)
	{	double[][][][]w=new double[5][5][N+1][N+1];
		for(int nx=0;nx<=N;nx++)
		{	for(int ny=0;ny<=N;ny++)
			{	w[0][0][nx][ny]=u0[nx][ny];
				w[1][0][nx][ny]=u1[nx][ny];
				w[2][0][nx][ny]=u2[nx][ny];
				w[3][0][nx][ny]=u3[nx][ny];
				w[4][0][nx][ny]=u4[nx][ny];
			}
		}
		for(int i=0;i<5;i++)
		{	for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(nx==0)
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx][ny])/dx;
						else if(nx==N)
							w[i][j+1][nx][ny]
						=(w[i][j][nx][ny]-w[i][j][nx-1][ny])/dx;
						else
							w[i][j+1][nx][ny]
						=(w[i][j][nx+1][ny]-w[i][j][nx-1][ny])/(2*dx);
					}
				}
			}
			for(int j=0;j<2;j++)
			{	for(int nx=0;nx<=N;nx++)
				{	for(int ny=0;ny<=N;ny++)
					{	if(ny==0)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny])/dy;
						else if(ny==N)
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny]-w[i][3*j][nx][ny-1])/dy;
						else
							w[i][j+3][nx][ny]
						=(w[i][3*j][nx][ny+1]-w[i][3*j][nx][ny-1])/(2*dy);
					}
				}
			}
		}
		return w;
	}
}