// XGraphicsFOtBbNXNX

package xxx;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.ImageObserver;
import javax.swing.JFrame;

public class XGraphics
{	// Graphics2DIuWFNg
	protected Graphics2D g;
	// [eBeBWn_̃VXeW
	private Point Org;
	// [eBeBWny
	private int yAx;
	// RXgN^(1)
	public XGraphics(Graphics g)
	{	this.g=(Graphics2D)g;
		set0(0,0,0);
	}
	// RXgN^(2)
	public XGraphics(Graphics2D g)
	{	this.g=g;
		set0(0,0,0);
	}
	// RXgN^(3)
	public XGraphics(JFrame fr)
	{	this.g=(Graphics2D)fr.getGraphics();
		set0(0,0,0);
	}
	// Graphics2DIuWFNg̎擾
	public Graphics2D getGraphics2D()
	{	return g;
	}
	// [eBeBWn̐ݒ(1)
	public void set0(int x,int y,int k)
	{	Org=new Point(x,y);
		if(k!=1)
			k=0;
		yAx=k;
	}
	// [eBeBWn̐ݒ(2)
	public void set0(Point p,int k)
	{	set0(p.x,p.y,k);
	}
	// _̎擾
	public Point get0()
	{	return Org;
	}
	// _̕`(1)
	public void pixel(int x,int y,Color c)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		g.setColor(c);
		g.drawLine(x_,y_,x_,y_);
	}
	// _̕`(2)
	public void pixel(Point p,Color c)
	{	pixel(p.x,p.y,c);
	}
	// ̕`(1)
	public void line(int x0,int y0,int x1,int y1,Color c,int w,int cap,int join)
	{	int x0_=x0+Org.x,y0_=y0*(1-2*yAx)+Org.y;
		int x1_=x1+Org.x,y1_=y1*(1-2*yAx)+Org.y;
		Line2D.Double sh=new Line2D.Double((double)x0_,(double)y0_,
			(double)x1_,(double)y1_);
		BasicStroke bs_old=(BasicStroke)g.getStroke();
		BasicStroke bs=new BasicStroke((float)w,cap,join);
		g.setStroke(bs);
		g.setColor(c);
		g.draw(sh);
		g.setStroke(bs_old);
		pixel(x1,y1,c);
	}
	// ̕`(2)
	public void line(int x0,int y0,int x1,int y1,Color c,int w)
	{	line(x0,y0,x1,y1,c,w,BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
	}
	// ̕`(3)
	public void line(int x0,int y0,int x1,int y1,Color c)
	{	line(x0,y0,x1,y1,c,1);
	}
	// ̕`(4)
	public void line(Point p0,Point p1,Color c,int w,int cap,int join)
	{	line(p0.x,p0.y,p1.x,p1.y,c,w,cap,join);
	}
	// ̕`(5)
	public void line(Point p0,Point p1,Color c,int w)
	{	line(p0,p1,c,w,BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
	}
	// ̕`(6)
	public void line(Point p0,Point p1,Color c)
	{	line(p0,p1,c,1);
	}
	// j̕`(1')
	public void line(int x0,int y0,int x1,int y1,Color c,int w,int d)
	{	int x0_=x0+Org.x,y0_=y0*(1-2*yAx)+Org.y;
		int x1_=x1+Org.x,y1_=y1*(1-2*yAx)+Org.y;
		float sp[]={(float)d,(float)d};
		Line2D.Double sh=new Line2D.Double((double)x0_,(double)y0_,
			(double)x1_,(double)y1_);
		BasicStroke bs_old=(BasicStroke)g.getStroke();
		BasicStroke bs=new BasicStroke((float)w,
			BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER,(float)d,sp,0f);
		g.setStroke(bs);
		g.setColor(c);
		g.draw(sh);
		g.setStroke(bs_old);
		pixel(x1,y1,c);
	}
	// j̕`(2')
	public void line(Point p0,Point p1,Color c,int w,int d)
	{	line(p0.x,p0.y,p1.x,p1.y,c,w,d);
	}
	// `̕`(1)
	public void rectangle(int x0,int y0,int x1,int y1,Color c,int w)
	{	int x0_=x0+Org.x,y0_=y0*(1-2*yAx)+Org.y;
		int x1_=x1+Org.x,y1_=y1*(1-2*yAx)+Org.y;
		if(x0_>x1_)
		{	int x=x0_;x0_=x1_;x1_=x;
		}
		if(y0_>y1_)
		{	int y=y0_;y0_=y1_;y1_=y;
		}
		Rectangle2D.Double sh=new Rectangle2D.Double((double)x0_,
			(double)y0_,(double)(x1_-x0_),(double)(y1_-y0_));
		BasicStroke bs_old=(BasicStroke)g.getStroke();
		BasicStroke bs=new BasicStroke((float)w,
			BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
		g.setStroke(bs);
		g.setColor(c);
		g.draw(sh);
		g.setStroke(bs_old);
	}
	// `̕`(2)
	public void rectangle(int x0,int y0,int x1,int y1,Color c)
	{	rectangle(x0,y0,x1,y1,c,1);
	}
	// `̕`(3)
	public void rectangle(Point p0,Point p1,Color c,int w)
	{	rectangle(p0.x,p0.y,p1.x,p1.y,c,w);
	}
	// `̕`(4)
	public void rectangle(Point p0,Point p1,Color c)
	{	rectangle(p0,p1,c,1);
	}
	// `̕`(5)
	public void rectangle(Rectangle r,Color c,int w)
	{	rectangle(r.x,r.y,r.x+r.width,r.y+r.height,c,w);
	}
	// `̕`(6)
	public void rectangle(Rectangle r,Color c)
	{	rectangle(r,c,1);
	}
	// hԂ`̕`(1)
	public void rectangleF(int x0,int y0,int x1,int y1,Color c)
	{	int x0_=x0+Org.x,y0_=y0*(1-2*yAx)+Org.y;
		int x1_=x1+Org.x,y1_=y1*(1-2*yAx)+Org.y;
		if(x0_>x1_)
		{	int x=x0_;x0_=x1_;x1_=x;
		}
		if(y0_>y1_)
		{	int y=y0_;y0_=y1_;y1_=y;
		}
		Rectangle2D.Double sh=new Rectangle2D.Double((double)x0_,
			(double)y0_,(double)(x1_-x0_+1),(double)(y1_-y0_+1));
		g.setColor(c);
		g.fill(sh);
	}
	// hԂ`̕`(2)
	public void rectangleF(Point p0,Point p1,Color c)
	{	rectangleF(p0.x,p0.y,p1.x,p1.y,c);
	}
	// hԂ`̕`(3)
	public void rectangleF(Rectangle r,Color c)
	{	rectangleF(r.x,r.y,r.x+r.width,r.y+r.height,c);
	}
	// p`̕`(1)
	public void polygon(int[]x,int[]y,int n,Color c,int w)
	{	int[]x_=new int[n];
		int[]y_=new int[n];
		for(int i=0;i<n;i++)
		{	x_[i]=x[i]+Org.x;y_[i]=y[i]*(1-2*yAx)+Org.y;
		}
		Polygon sh=new Polygon(x_,y_,n);
		BasicStroke bs_old=(BasicStroke)g.getStroke();
		BasicStroke bs=new BasicStroke((float)w,
			BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
		g.setStroke(bs);
		g.setColor(c);
		g.draw(sh);
		g.setStroke(bs_old);
	}
	// p`̕`(2)
	public void polygon(int[]x,int[]y,int n,Color c)
	{	polygon(x,y,n,c,1);
	}
	// p`̕`(3)
	public void polygon(Point[]p,int n,Color c,int w)
	{	int[]x=new int[n];
		int[]y=new int[n];
		for(int i=0;i<n;i++)
		{	x[i]=p[i].x;y[i]=p[i].y;
		}
		polygon(x,y,n,c,w);
	}
	// p`̕`(4)
	public void polygon(Point[]p,int n,Color c)
	{	polygon(p,n,c,1);
	}
	// hԂp`̕`(1)
	public void polygonF(int[]x,int[]y,int n,Color c)
	{	int[]x_=new int[n];
		int[]y_=new int[n];
		for(int i=0;i<n;i++)
		{	x_[i]=x[i]+Org.x;y_[i]=y[i]*(1-2*yAx)+Org.y;
		}
		Polygon sh=new Polygon(x_,y_,n);
		g.setColor(c);
		g.fill(sh);
	}
	// hԂp`̕`(2)
	public void polygonF(Point[]p,int n,Color c)
	{	int[]x=new int[n];
		int[]y=new int[n];
		for(int i=0;i<n;i++)
		{	x[i]=p[i].x;y[i]=p[i].y;
		}
		polygonF(x,y,n,c);
	}
	// 3p`̕`(1)
	public void triangle(int x0,int y0,int x1,int y1,int x2,int y2,
		Color c,int w)
	{	int[]x=new int[3];
		int[]y=new int[3];
		x[0]=x0;x[1]=x1;x[2]=x2;
		y[0]=y0;y[1]=y1;y[2]=y2;
		polygon(x,y,3,c,w);
	}
	// 3p`̕`(2)
	public void triangle(int x0,int y0,int x1,int y1,int x2,int y2,
		Color c)
	{	triangle(x0,y0,x1,y1,x2,y2,c,1);
	}
	// 3p`̕`(3)
	public void triangle(Point p0,Point p1,Point p2,Color c,int w)
	{	triangle(p0.x,p0.y,p1.x,p1.y,p2.x,p2.y,c,w);
	}
	// 3p`̕`(4)
	public void triangle(Point p0,Point p1,Point p2,Color c)
	{	triangle(p0,p1,p2,c,1);
	}
	// hԂ3p`̕`(1)
	public void triangleF(int x0,int y0,int x1,int y1,int x2,int y2,
		Color c)
	{	int[]x=new int[3];
		int[]y=new int[3];
		x[0]=x0;x[1]=x1;x[2]=x2;
		y[0]=y0;y[1]=y1;y[2]=y2;
		polygonF(x,y,3,c);
	}
	// hԂ3p`̕`(2)
	public void triangleF(Point p0,Point p1,Point p2,Color c)
	{	triangleF(p0.x,p0.y,p1.x,p1.y,p2.x,p2.y,c);
	}
	// ȉ~̕`(1)
	public void ellipse(int x,int y,int rx,int ry,Color c,int w)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		Ellipse2D.Double sh=new Ellipse2D.Double((double)(x_-rx),
			(double)(y_-ry),(double)(2*rx),(double)(2*ry));
		BasicStroke bs_old=(BasicStroke)g.getStroke();
		BasicStroke bs=new BasicStroke((float)w,
			BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
		g.setStroke(bs);
		g.setColor(c);
		g.draw(sh);
		g.setStroke(bs_old);
	}
	// ȉ~̕`(2)
	public void ellipse(int x,int y,int rx,int ry,Color c)
	{	ellipse(x,y,rx,ry,c,1);
	}
	// ȉ~̕`(3)
	public void ellipse(Point p,Dimension d,Color c,int w)
	{	ellipse(p.x,p.y,d.width,d.height,c,w);
	}
	// ȉ~̕`(4)
	public void ellipse(Point p,Dimension d,Color c)
	{	ellipse(p,d,c,1);
	}
	// Xȉ~̕`(1')
	public void ellipse(int x,int y,int rx,int ry,int ang,Color c,int w)
	{	int n=180;
		int[]xx=new int[n];
		int[]yy=new int[n];
		for(int i=0;i<n/2;i++)
		{	double x_=rx*Math.cos(2*i*Math.PI/n);
			double y_=ry*Math.sin(2*i*Math.PI/n);
			int u=XMath.fint(x_*Math.cos(ang*Math.PI/180)
				-y_*Math.sin(ang*Math.PI/180));
			int v=XMath.fint(x_*Math.sin(ang*Math.PI/180)
				+y_*Math.cos(ang*Math.PI/180));
			xx[i]=x+u;xx[i+n/2]=x-u;
			yy[i]=y+v;yy[i+n/2]=y-v;
		}
		polygon(xx,yy,n,c,w);
	}
	// Xȉ~̕`(2')
	public void ellipse(int x,int y,int rx,int ry,int ang,Color c)
	{	ellipse(x,y,rx,ry,ang,c,1);
	}
	// Xȉ~̕`(3')
	public void ellipse(Point p,Dimension d,int ang,Color c,int w)
	{	ellipse(p.x,p.y,d.width,d.height,ang,c,w);
	}
	// Xȉ~̕`(4')
	public void ellipse(Point p,Dimension d,int ang,Color c)
	{	ellipse(p,d,ang,c,1);
	}
	// hԂȉ~̕`(1)
	public void ellipseF(int x,int y,int rx,int ry,Color c)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		Ellipse2D.Double sh=new Ellipse2D.Double((double)(x_-rx),
			(double)(y_-ry),(double)(2*rx),(double)(2*ry));
		g.setColor(c);
		g.fill(sh);
		g.draw(sh);
	}
	// hԂȉ~̕`(2)
	public void ellipseF(Point p,Dimension d,Color c)
	{	ellipseF(p.x,p.y,d.width,d.height,c);
	}
	// hԂ(X)ȉ~̕`(1')
	public void ellipseF(int x,int y,int rx,int ry,int ang,Color c)
	{	int n=180;
		int[]xx=new int[n];
		int[]yy=new int[n];
		for(int i=0;i<n/2;i++)
		{	double x_=rx*Math.cos(2*i*Math.PI/n);
			double y_=ry*Math.sin(2*i*Math.PI/n);
			int u=XMath.fint(x_*Math.cos(ang*Math.PI/180)
				-y_*Math.sin(ang*Math.PI/180));
			int v=XMath.fint(x_*Math.sin(ang*Math.PI/180)
				+y_*Math.cos(ang*Math.PI/180));
			xx[i]=x+u;xx[i+n/2]=x-u;
			yy[i]=y+v;yy[i+n/2]=y-v;
		}
		polygonF(xx,yy,n,c);
	}
	// hԂ(X)ȉ~̕`(2')
	public void ellipseF(Point p,Dimension d,int ang,Color c)
	{	ellipseF(p.x,p.y,d.width,d.height,ang,c);
	}
	// JDK1.1ɂȉ~̕`(1")
	public void oval(int x,int y,int rx,int ry,Color c)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		g.setColor(c);
		g.drawOval(x_-rx,y_-ry,2*rx,2*ry);
	}
	// JDK1.1ɂȉ~̕`(2")
	public void oval(Point p,Dimension d,Color c)
	{	oval(p.x,p.y,d.width,d.height,c);
	}
	// JDK1.1ɂhԂȉ~̕`(1")
	public void ovalF(int x,int y,int rx,int ry,Color c)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		g.setColor(c);
		g.fillOval(x_-rx,y_-ry,2*rx+1,2*ry+1);
		oval(x,y,rx,ry,c);
	}
	// JDK1.1ɂhԂȉ~̕`(2")
	public void ovalF(Point p,Dimension d,Color c)
	{	ovalF(p.x,p.y,d.width,d.height,c);
	}
	// ~̕`(1)
	public void circle(int x,int y,int r,Color c,int w)
	{	ellipse(x,y,r,r,c,w);
	}
	// ~̕`(2)
/*	public void circle(int x,int y,int r,Color c)
	{	circle(x,y,r,c,1);
	}*/
	// ~̕`(3)
	public void circle(Point p,int r,Color c,int w)
	{	circle(p.x,p.y,r,c,w);
	}
	// ~̕`(4)
/*	public void circle(Point p,int r,Color c)
	{	circle(p,r,c,1);
	}*/
	// JDK1.1ɂ~̕`(1')
	public void circle(int x,int y,int r,Color c)
	{	oval(x,y,r,r,c);
	}
	// JDK1.1ɂ~̕`(2')
	public void circle(Point p,int r,Color c)
	{	circle(p.x,p.y,r,c);
	}
	// JDK1.1ɂhԂ~̕`(1)
	public void circleF(int x,int y,int r,Color c)
	{	ovalF(x,y,r,r,c);
	}
	// JDK1.1ɂhԂ~̕`(2)
	public void circleF(Point p,int r,Color c)
	{	circleF(p.x,p.y,r,c);
	}
	// ̕`(1)
	public void string(int x,int y,String str,Color c,
		String name,int style,int size)
	{	Font f=new Font(name,style,size);
		g.setFont(f);
		g.setColor(c);
		g.drawString(str,x,y);
	}
	// ̕`(2)
	public void string(int x,int y,String str,Color c,int size)
	{	string(x,y,str,c,"Arial",Font.PLAIN,size);
	}
	// ̕`(3)
	public void string(Point p,String str,Color c,
		String name,int style,int size)
	{	string(p.x,p.y,str,c,name,style,size);
	}
	// ̕`(4)
	public void string(Point p,String str,Color c,int size)
	{	string(p,str,c,"Arial",Font.PLAIN,size);
	}
	// ̕`(1')
	public void string2(int x,int y,String str,Color c,
		String name,int style,int size)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		string(x_,y_,str,c,name,style,size);
	}
	// ̕`(2')
	public void string2(int x,int y,String str,Color c,int size)
	{	string2(x,y,str,c,"Arial",Font.PLAIN,size);
	}
	// ̕`(3')
	public void string2(Point p,String str,Color c,
		String name,int style,int size)
	{	string2(p.x,p.y,str,c,name,style,size);
	}
	// ̕`(4')
	public void string2(Point p,String str,Color c,int size)
	{	string2(p,str,c,"Arial",Font.PLAIN,size);
	}
	// ̉]ƕ`(1)
	public void stringR(int x,int y,String str,Color c,
		String name,int style,int size,double ang)
	{	Font f=new Font(name,style,size);
		g.setFont(f);
		g.setColor(c);
		g.rotate(-ang*Math.PI/180,x,y);
		g.drawString(str,x,y);
		AffineTransform af=new AffineTransform();
		g.setTransform(af);
	}
	// ̉]ƕ`(2)
	public void stringR(int x,int y,String str,Color c,int size,double ang)
	{	stringR(x,y,str,c,"Arial",Font.PLAIN,size,ang);
	}
	// ̉]ƕ`(3)
	public void stringR(Point p,String str,Color c,
		String name,int style,int size,double ang)
	{	stringR(p.x,p.y,str,c,name,style,size,ang);
	}
	// ̉]ƕ`(4)
	public void stringR(Point p,String str,Color c,int size,double ang)
	{	stringR(p,str,c,"Arial",Font.PLAIN,size,ang);
	}
	// ̉]ƕ`(1')
	public void stringR2(int x,int y,String str,Color c,
		String name,int style,int size,double ang)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		stringR(x_,y_,str,c,name,style,size,ang);
	}
	// ̉]ƕ`(2')
	public void stringR2(int x,int y,String str,Color c,int size,
		double ang)
	{	stringR2(x,y,str,c,"Arial",Font.PLAIN,size,ang);
	}
	// ̉]ƕ`(3')
	public void stringR2(Point p,String str,Color c,
		String name,int style,int size,double ang)
	{	stringR2(p.x,p.y,str,c,name,style,size,ang);
	}
	// ̉]ƕ`(4')
	public void stringR2(Point p,String str,Color c,int size,
		double ang)
	{	stringR2(p,str,c,"Arial",Font.PLAIN,size,ang);
	}
	// ~̕`(1)
	public void cross(int x,int y,int r,Color c,int w)
	{	line(x-r,y-r,x+r,y+r,c,w);
		line(x-r,y+r,x+r,y-r,c,w);
	}
	// ~̕`(2)
	public void cross(Point p,int r,Color c,int w)
	{	cross(p.x,p.y,r,c,w);
	}
	// +̕`(1)
	public void plus(int x,int y,int r,Color c,int w)
	{	line(x-r,y,x+r,y,c,w);
		line(x,y+r,x,y-r,c,w);
	}
	// +̕`(2)
	public void plus(Point p,int r,Color c,int w)
	{	plus(p.x,p.y,r,c,w);
	}
	// ̕`(1)
	public void box(int x,int y,int r,Color c)
	{	rectangleF(x-r,y-r,x+r,y+r,c);
	}
	// ̕`(2)
	public void box(Point p,int r,Color c)
	{	box(p.x,p.y,r,c);
	}
	// ̕`(1)
	public void disk(int x,int y,int r,Color c)
	{	circleF(x,y,r,c);
	}
	// ̕`(2)
	public void disk(Point p,int r,Color c)
	{	disk(p.x,p.y,r,c);
	}
	// ̕`(1)
	public void arrow(int x0,int y0,int x1,int y1,Color c,int w,int s)
	{	double ang=Math.atan2((double)(y1-y0),(double)(x1-x0));
		int[]x=new int[4];
		int[]y=new int[4];
		x[0]=x1;y[0]=y1;
		x[1]=x1-(int)(s*Math.cos(ang-Math.PI/12));
		y[1]=y1-(int)(s*Math.sin(ang-Math.PI/12));
		x[2]=x1-(int)(s*Math.cos(ang+Math.PI/12));
		y[2]=y1-(int)(s*Math.sin(ang+Math.PI/12));
		x[3]=x1-(int)(2*s*Math.cos(ang)/3);
		y[3]=y1-(int)(2*s*Math.sin(ang)/3);
		line(x0,y0,x[3],y[3],c,w);
		polygonF(x,y,3,c);
	}
	// ̕`(2)
	public void arrow(Point p0,Point p1,Color c,int w,int s)
	{	arrow(p0.x,p0.y,p1.x,p1.y,c,w,s);
	}
	// ʂ̏
	public void cls(Dimension d)
	{	g.clearRect(0,0,d.width,d.height);
	}
	// C[W̕`(1)
	public void image(Image im,int x,int y,ImageObserver ob)
	{	int x_=x+Org.x,y_=y*(1-2*yAx)+Org.y;
		((Graphics)g).drawImage(im,x_,y_,ob);
	}
	// C[W̕`(2)
	public void image(Image im,Point p,ImageObserver ob)
	{	image(im,p.x,p.y,ob);
	}
}