// XMathFZNX

package xxx;

import java.awt.Point;

public final class XMath
{	// _ȉ̎ľܓ(doubleint)
	public static int fint(double x)
	{	return (int)Math.floor(x+0.5);
	}
	// _ȉ̎ľܓ(XPointDPoint)
	public static Point fint(XPointD p)
	{	return new Point(fint(p.x),fint(p.y));
	}
	// _ȉ̎ľܓ(doublez񂩂intz)
	public static int[]fint(double[]x)
	{	int[]xx=new int[x.length];
		for(int i=0;i<x.length;i++)
			xx[i]=fint(x[i]);
		return xx;
	}
	// _ȉ̎ľܓ(XPointDz񂩂Pointz)
	public static Point[]fint(XPointD[]p)
	{	Point[]pp=new Point[p.length];
		for(int i=0;i<p.length;i++)
			pp[i]=fint(p[i]);
		return pp;
	}
	// _(n+1)P^ȉ̎ľܓ(doubledouble)
	public static double fdouble(double x,int n)
	{	double d=Math.pow(10.0,(double)n);
		return (double)(fint(x*d))/d;
	}
	// _(n+1)P^ȉ̎ľܓ(doublez񂩂doublez)
	public static double[]fdouble(double[]x,int n)
	{	double[]xx=new double[x.length];
		for(int i=0;i<x.length;i++)
			xx[i]=fdouble(x[i],n);
		return xx;
	}
	// +Z(Point)
	public static Point plus(Point p0,Point p1)
	{	return new Point(p0.x+p1.x,p0.y+p1.y);
	}
	public static Point plus(Point p0,Point p1,Point p2)
	{	return new Point(p0.x+p1.x+p2.x,p0.y+p1.y+p2.y);
	}
	// +Z(XPointD)
	public static XPointD plus(XPointD p0,XPointD p1)
	{	return new XPointD(p0.x+p1.x,p0.y+p1.y);
	}
	public static XPointD plus(XPointD p0,XPointD p1,XPointD p2)
	{	return new XPointD(p0.x+p1.x+p2.x,p0.y+p1.y+p2.y);
	}
	// +Z(XPointD3)
	public static XPointD3 plus(XPointD3 p0,XPointD3 p1)
	{	return new XPointD3(p0.x+p1.x,p0.y+p1.y,p0.z+p1.z);
	}
	public static XPointD3 plus(XPointD3 p0,XPointD3 p1,XPointD3 p2)
	{	return new XPointD3(p0.x+p1.x+p2.x,p0.y+p1.y+p2.y,
			p0.z+p1.z+p2.z);
	}
	// -Z(Point)
	public static Point minus(Point p)
	{	return new Point(-p.x,-p.y);
	}
	public static Point minus(Point p0,Point p1)
	{	return new Point(p0.x-p1.x,p0.y-p1.y);
	}
	// -Z(XPointD)
	public static XPointD minus(XPointD p)
	{	return new XPointD(-p.x,-p.y);
	}
	public static XPointD minus(XPointD p0,XPointD p1)
	{	return new XPointD(p0.x-p1.x,p0.y-p1.y);
	}
	// -Z(XPointD3)
	public static XPointD3 minus(XPointD3 p)
	{	return new XPointD3(-p.x,-p.y,-p.z);
	}
	public static XPointD3 minus(XPointD3 p0,XPointD3 p1)
	{	return new XPointD3(p0.x-p1.x,p0.y-p1.y,p0.z-p1.z);
	}
	// *Z(Point)
	public static Point mlt(int k,Point p)
	{	return new Point(k*p.x,k*p.y);
	}
	public static Point mlt(Point p,int k)
	{	return mlt(k,p);
	}
	public static XPointD mlt(double k,Point p)
	{	return new XPointD(k*p.x,k*p.y);
	}
	public static XPointD mlt(Point p,double k)
	{	return mlt(k,p);
	}
	// *Z(XPointD)
	public static XPointD mlt(int k,XPointD p)
	{	return new XPointD(k*p.x,k*p.y);
	}
	public static XPointD mlt(XPointD p,int k)
	{	return mlt(k,p);
	}
	public static XPointD mlt(double k,XPointD p)
	{	return new XPointD(k*p.x,k*p.y);
	}
	public static XPointD mlt(XPointD p,double k)
	{	return mlt(k,p);
	}
	// *Z(XPointD3)
	public static XPointD3 mlt(int k,XPointD3 p)
	{	return new XPointD3(k*p.x,k*p.y,k*p.z);
	}
	public static XPointD3 mlt(XPointD3 p,int k)
	{	return mlt(k,p);
	}
	public static XPointD3 mlt(double k,XPointD3 p)
	{	return new XPointD3(k*p.x,k*p.y,k*p.z);
	}
	public static XPointD3 mlt(XPointD3 p,double k)
	{	return mlt(k,p);
	}
	// /Z(Point)
	public static XPointD div(Point p,int k)
	{	return new XPointD((double)p.x/(double)k,(double)p.y/(double)k);
	}
	public static XPointD div(Point p,double k)
	{	return new XPointD((double)p.x/k,(double)p.y/k);
	}
	// /Z(XPointD)
	public static XPointD div(XPointD p,int k)
	{	return new XPointD(p.x/(double)k,p.y/(double)k);
	}
	public static XPointD div(XPointD p,double k)
	{	return new XPointD(p.x/k,p.y/k);
	}
	// /Z(XPointD3)
	public static XPointD3 div(XPointD3 p,int k)
	{	return new XPointD3(p.x/(double)k,p.y/(double)k,
			p.z/(double)k);
	}
	public static XPointD3 div(XPointD3 p,double k)
	{	return new XPointD3(p.x/k,p.y/k,p.z/k);
	}
	// Βl(Point)
	public static double abs(Point p)
	{	return Math.sqrt((double)abs2(p));
	}
	// Βl(XPointD)
	public static double abs(XPointD p)
	{	return Math.sqrt(abs2(p));
	}
	// Βl(XPointD3)
	public static double abs(XPointD3 p)
	{	return Math.sqrt(abs2(p));
	}
	// Βl2(Point)
	public static int abs2(Point p)
	{	return p.x*p.x+p.y*p.y;
	}
	// Βl2(XPointD)
	public static double abs2(XPointD p)
	{	return p.x*p.x+p.y*p.y;
	}
	// Βl2(XPointD3)
	public static double abs2(XPointD3 p)
	{	return p.x*p.x+p.y*p.y+p.z*p.z;
	}
	// PʃxNg(Point)
	public static XPointD ev(Point p)
	{	double d=abs(p);
		if(d>0.0)
			return div(p,d);
		else
			return div(p,1);
	}
	// PʃxNg(XPointD)
	public static XPointD ev(XPointD p)
	{	double d=abs(p);
		if(d>0.0)
			return div(p,d);
		else
			return p;
	}
	// PʃxNg(XPointD3)
	public static XPointD3 ev(XPointD3 p)
	{	double d=abs(p);
		if(d>0.0)
			return div(p,d);
		else
			return p;
	}
	// (Point)
	public static int ip(Point p0,Point p1)
	{	return p0.x*p1.x+p0.y*p1.y;
	}
	// (XPointD)
	public static double ip(XPointD p0,XPointD p1)
	{	return p0.x*p1.x+p0.y*p1.y;
	}
	// (XPointD3)
	public static double ip(XPointD3 p0,XPointD3 p1)
	{	return p0.x*p1.x+p0.y*p1.y+p0.z*p1.z;
	}
	// Kiꂽ(Point)
	public static double nip(Point p0,Point p1)
	{	return ip(ev(p0),ev(p1));
	}
	// Kiꂽ(XPointD)
	public static double nip(XPointD p0,XPointD p1)
	{	return ip(ev(p0),ev(p1));
	}
	// Kiꂽ(XPointD3)
	public static double nip(XPointD3 p0,XPointD3 p1)
	{	return ip(ev(p0),ev(p1));
	}
	// O(Point)
	public static int op(Point p0,Point p1)
	{	return p0.x*p1.y-p0.y*p1.x;
	}
	public static int op(Point p0,Point p1,Point p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return op(p1,p2);
	}
	// O(XPointD)
	public static double op(XPointD p0,XPointD p1)
	{	return p0.x*p1.y-p0.y*p1.x;
	}
	public static double op(XPointD p0,XPointD p1,XPointD p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return op(p1,p2);
	}
	// O(XPointD3)
	public static XPointD3 op(XPointD3 p0,XPointD3 p1)
	{	double x=p0.y*p1.z-p0.z*p1.y;
		double y=p0.z*p1.x-p0.x*p1.z;
		double z=p0.x*p1.y-p0.y*p1.x;
		return new XPointD3(x,y,z);
	}
	public static XPointD3 op(XPointD3 p0,XPointD3 p1,XPointD3 p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return op(p1,p2);
	}
	// KiꂽO(Point)
	public static double nop(Point p0,Point p1)
	{	return op(ev(p0),ev(p1));
	}
	public static double nop(Point p0,Point p1,Point p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return nop(p1,p2);
	}
	// KiꂽO(XPointD)
	public static double nop(XPointD p0,XPointD p1)
	{	return op(ev(p0),ev(p1));
	}
	public static double nop(XPointD p0,XPointD p1,XPointD p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return nop(p1,p2);
	}
	// KiꂽO(XPointD3)
	public static XPointD3 nop(XPointD3 p0,XPointD3 p1)
	{	return ev(op(p0,p1));
	}
	public static XPointD3 nop(XPointD3 p0,XPointD3 p1,XPointD3 p2)
	{	p1=minus(p1,p0);p2=minus(p2,p0);
		return nop(p1,p2);
	}
	// _̉̉](XPointD)
	public static XPointD rot(double x,double y,double ang)
	{	double xx=x*Math.cos(ang*Math.PI/180)
			-y*Math.sin(ang*Math.PI/180);
		double yy=x*Math.sin(ang*Math.PI/180)
			+y*Math.cos(ang*Math.PI/180);
		return new XPointD(xx,yy);
	}
	public static XPointD rot(XPointD p,double ang)
	{	return rot(p.x,p.y,ang);
	}
	// x̉̉](XPointD3)
	public static XPointD3 rotX(double x,double y,double z,double ang)
	{	double yy=y*Math.cos(ang*Math.PI/180)
			-z*Math.sin(ang*Math.PI/180);
		double zz=y*Math.sin(ang*Math.PI/180)
			+z*Math.cos(ang*Math.PI/180);
		return new XPointD3(x,yy,zz);
	}
	public static XPointD3 rotX(XPointD3 p,double ang)
	{	return rotX(p.x,p.y,p.z,ang);
	}
	// ỷ̉](XPointD3)
	public static XPointD3 rotY(double x,double y,double z,double ang)
	{	double zz=z*Math.cos(ang*Math.PI/180)
			-x*Math.sin(ang*Math.PI/180);
		double xx=z*Math.sin(ang*Math.PI/180)
			+x*Math.cos(ang*Math.PI/180);
		return new XPointD3(xx,y,zz);
	}
	public static XPointD3 rotY(XPointD3 p,double ang)
	{	return rotY(p.x,p.y,p.z,ang);
	}
	// z̉̉](XPointD3)
	public static XPointD3 rotZ(double x,double y,double z,double ang)
	{	double xx=x*Math.cos(ang*Math.PI/180)
			-y*Math.sin(ang*Math.PI/180);
		double yy=x*Math.sin(ang*Math.PI/180)
			+y*Math.cos(ang*Math.PI/180);
		return new XPointD3(xx,yy,z);
	}
	public static XPointD3 rotZ(XPointD3 p,double ang)
	{	return rotZ(p.x,p.y,p.z,ang);
	}
}
